'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactAddonsShallowCompare = require('react-addons-shallow-compare');

var _reactAddonsShallowCompare2 = _interopRequireDefault(_reactAddonsShallowCompare);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _d3Shape = require('d3-shape');

var _d3Scale = require('d3-scale');

var _dataDenormalizer = require('./helpers/dataDenormalizer');

var _dataDenormalizer2 = _interopRequireDefault(_dataDenormalizer);

var _stackedDataDenormalizer = require('./helpers/stackedDataDenormalizer');

var _stackedDataDenormalizer2 = _interopRequireDefault(_stackedDataDenormalizer);

var _customPropTypes = require('./propTypes/customPropTypes');

var _scaleHelpers = require('./helpers/scaleHelpers');

var _splitHTMLElementProps = require('./helpers/splitHTMLElementProps');

var _splitHTMLElementProps2 = _interopRequireDefault(_splitHTMLElementProps);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var boundingClientRectProps = ['bottom', 'height', 'left', 'right', 'top', 'width'];

var d3Scales = {
  scaleBand: _d3Scale.scaleBand,
  scaleLinear: _d3Scale.scaleLinear,
  scaleOrdinal: _d3Scale.scaleOrdinal,
  scaleThreshold: _d3Scale.scaleThreshold,
  scaleSqrt: _d3Scale.scaleSqrt,
  scaleTime: _d3Scale.scaleTime
};

var Chart = function (_Component) {
  (0, _inherits3.default)(Chart, _Component);

  function Chart(props) {
    var _ref;

    (0, _classCallCheck3.default)(this, Chart);

    for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      args[_key - 1] = arguments[_key];
    }

    var _this = (0, _possibleConstructorReturn3.default)(this, (_ref = Chart.__proto__ || (0, _getPrototypeOf2.default)(Chart)).call.apply(_ref, [this, props].concat(args)));

    _this.onWindowResize = function () {
      _this.resize(_this.props);
    };

    _this.renderChild = function (child) {
      var i = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;

      if (typeof child.type === 'string') {
        return child;
      }
      return _react2.default.cloneElement(child, (0, _extends3.default)({
        key: i,
        originalData: _this.props.data,
        chartData: _this.chartData,
        xScale: _this.xScale,
        yScale: _this.yScale,
        xScaleDomain: _this.props.xScaleDomain,
        yScaleDomain: _this.props.yScaleDomain,
        yScaleMinimum: _this.props.yScaleMinimum,
        yScaleMaximum: _this.props.yScaleMaximum,
        classNamePrefix: _this.props.className,
        layout: _this.props.layout,
        paddingBottom: _this.props.paddingBottom,
        paddingLeft: _this.props.paddingLeft,
        paddingRight: _this.props.paddingRight,
        paddingTop: _this.props.paddingTop,
        valueKeys: _this.props.valueKeys,
        DEBUG: _this.props.DEBUG
      }, _this.state, child.props, {
        children: child.props.children
      }));
    };

    _this.onWindowResize = _lodash2.default.debounce(_this.onWindowResize, props.resizeDebounce);
    _this.setupData(props);
    _this.state = {};
    return _this;
  }

  (0, _createClass3.default)(Chart, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.resize(this.props);
      window.addEventListener('resize', this.onWindowResize);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      this.setupData(nextProps);
      this.resize(nextProps);
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate() {
      for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        args[_key2] = arguments[_key2];
      }

      return _reactAddonsShallowCompare2.default.apply(undefined, [this].concat(args));
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      if (!this.props.skipAfterUpdateRender) {
        this.resize(this.props); // let's check if layout has been changed
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      window.removeEventListener('resize', this.onWindowResize);
    }
  }, {
    key: 'setupData',
    value: function setupData(props) {
      var data = this.calculateData(props);
      this.xScale = this.setupScale(props.xScale);
      this.yScale = this.setupScale(props.yScale);
      this.updateScalesFromData(props, data);
      this.chartData = data || [];
      this.rect = null;
    }
  }, {
    key: 'setupScale',
    value: function setupScale(prop) {
      return _lodash2.default.isFunction(prop) ? prop() : d3Scales[prop]();
    }
  }, {
    key: 'getValue',
    value: function getValue(d, key) {
      return isNaN(d[key]) ? 0 : d[key];
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _splitHTMLElementProp = (0, _splitHTMLElementProps2.default)(this.props),
          _splitHTMLElementProp2 = (0, _slicedToArray3.default)(_splitHTMLElementProp, 1),
          elementProps = _splitHTMLElementProp2[0];

      var renderElementProps = _lodash2.default.omit(elementProps, ['data', 'height', 'width', 'style']);
      var style = (0, _extends3.default)({}, elementProps.style || {});

      if (this.props.height) {
        style.height = this.sizeToStyle(this.props.height);
      }
      if (this.props.width) {
        style.width = this.sizeToStyle(this.props.width);
      }

      if (this.props.tagName === 'svg') {
        var viewBox = void 0;
        if (this.state.width && this.state.height) {
          viewBox = '0 0 ' + this.state.width + ' ' + this.state.height;
        }
        return _react2.default.createElement(
          'svg',
          (0, _extends3.default)({}, renderElementProps, {
            style: style,
            ref: function ref(n) {
              return _this2.node = n;
            },
            viewBox: viewBox,
            xmlns: this.props.xmlns
          }),
          this.renderChildren()
        );
      }

      var Type = this.props.tagName;
      return _react2.default.createElement(
        Type,
        (0, _extends3.default)({}, renderElementProps, {
          ref: function ref(n) {
            return _this2.node = n;
          },
          style: style
        }),
        this.renderChildren()
      );
    }
  }, {
    key: 'renderChildren',
    value: function renderChildren() {
      if (!this.node) {
        return undefined;
      }
      var children = this.props.children;
      if (_lodash2.default.isArray(children)) {
        children = children.filter(function (i) {
          return i;
        });
      }
      return _react2.default.Children.map(children, this.renderChild);
    }
  }, {
    key: 'calculateData',
    value: function calculateData(props) {
      if (props.layout === 'stack') {
        var stack = (0, _d3Shape.stack)().keys(props.valueKeys).value(this.getValue);

        return this.caluateStackedData(stack(props.data), props.xKey);
      } else {
        return this.calculateDenormalizedData(props.valueKeys || [], props.xKey, props.data || []);
      }
    }
  }, {
    key: 'calculateDenormalizedData',
    value: function calculateDenormalizedData(valueKeys, xKey, data) {
      return valueKeys.map(function (valueKey) {
        return (0, _dataDenormalizer2.default)(data || [], xKey, valueKey);
      });
    }
  }, {
    key: 'caluateStackedData',
    value: function caluateStackedData(data, xKey) {
      return data.map(function (stackedData) {
        return (0, _stackedDataDenormalizer2.default)(stackedData, xKey, stackedData.key);
      });
    }
  }, {
    key: 'updateScalesFromData',
    value: function updateScalesFromData(props, data) {
      if (props.xKey) {
        (0, _scaleHelpers.updateXScaleDomain)(this.xScale, props, data);
      }
      (0, _scaleHelpers.updateYScaleDomain)(this.yScale, props, data);
    }
  }, {
    key: 'resize',
    value: function resize(props) {
      if (!this.node) {
        return; // its debounced so its possible that its unmounted.
      }

      // if rect didn't change there is no need to re-render
      var newRect = _lodash2.default.pick(this.node.getBoundingClientRect(), boundingClientRectProps);
      if (_lodash2.default.isEqual(this.rect, newRect)) {
        return;
      }

      this.rect = newRect;
      var height = this.propSizeOrRect(props.height, this.rect.height);
      var width = this.propSizeOrRect(props.width, this.rect.width);
      var areaWidth = width - (props.paddingLeft + props.paddingRight);
      var areaHeight = height - (props.paddingTop + props.paddingBottom);
      var rangeMethod = props.rangeRound ? 'rangeRound' : 'range';
      this.xScale[rangeMethod]([0, areaWidth]);
      this.yScale[rangeMethod]([areaHeight, 0]);

      this.setState({
        height: height,
        width: width,
        areaHeight: areaHeight,
        areaWidth: areaWidth
      });
      if (props.DEBUG) {
        /* eslint-disable no-console */
        console.debug('xScale range:', [0, areaWidth]);
        console.debug('yScale range:', [areaHeight, 0]);
        console.debug('settingSize: height:' + height + ', width:' + width + ', areaHeight:' + areaHeight + ', areaWidth:' + areaWidth);
      }
    }
  }, {
    key: 'propSizeOrRect',
    value: function propSizeOrRect(defined, fromRect) {
      if (this.isPercentage(defined)) {
        return fromRect;
      }
      return defined || fromRect;
    }
  }, {
    key: 'isPercentage',
    value: function isPercentage(size) {
      return _lodash2.default.isString(size) && _lodash2.default.endsWith(size, '%');
    }
  }, {
    key: 'sizeToStyle',
    value: function sizeToStyle(size) {
      if (this.isPercentage(size)) {
        return size;
      }
      return size + 'px';
    }
  }]);
  return Chart;
}(_react.Component);

Chart.propTypes = {
  DEBUG: _propTypes2.default.bool,
  children: _propTypes2.default.node,
  className: _propTypes2.default.string,
  data: _propTypes2.default.array,
  height: _customPropTypes.stringOrNumber,
  id: _propTypes2.default.string,
  layout: _propTypes2.default.string,
  paddingBottom: _propTypes2.default.number,
  paddingLeft: _propTypes2.default.number,
  paddingRight: _propTypes2.default.number,
  paddingTop: _propTypes2.default.number,
  resizeDebounce: _propTypes2.default.number,
  valueKeys: _propTypes2.default.array,
  width: _customPropTypes.stringOrNumber,
  xKey: _propTypes2.default.string,
  xScale: _customPropTypes.stringOrFunc,
  xScaleDomain: _customPropTypes.arrayOrFunc,
  xmlns: _propTypes2.default.string,
  yScale: _customPropTypes.stringOrFunc,
  yScaleDomain: _customPropTypes.arrayOrFunc,
  yScaleMaximum: _propTypes2.default.number,
  yScaleMinimum: _propTypes2.default.number,
  rangeRound: _propTypes2.default.bool,
  tagName: _propTypes2.default.string.isRequired,
  skipAfterUpdateRender: _propTypes2.default.bool
};
Chart.defaultProps = {
  paddingBottom: 0,
  paddingLeft: 0,
  paddingRight: 0,
  paddingTop: 0,
  resizeDebounce: 100,
  valueKeys: ['value'],
  xScale: 'scaleTime',
  xmlns: 'http://www.w3.org/2000/svg',
  yScale: 'scaleLinear',
  rangeRound: false,
  tagName: 'svg'
};
var _default = Chart;
exports.default = _default;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(boundingClientRectProps, 'boundingClientRectProps', 'src/Chart.js');

  __REACT_HOT_LOADER__.register(d3Scales, 'd3Scales', 'src/Chart.js');

  __REACT_HOT_LOADER__.register(Chart, 'Chart', 'src/Chart.js');

  __REACT_HOT_LOADER__.register(_default, 'default', 'src/Chart.js');
}();

;