'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _d3Selection = require('d3-selection');

var _d3Transition = require('d3-transition');

var _d3Ease = require('d3-ease');

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _customPropTypes = require('../propTypes/customPropTypes');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var d3Eases = {
  easePolyInOut: _d3Ease.easePolyInOut
};

var VerticalCurtain = function (_Component) {
  (0, _inherits3.default)(VerticalCurtain, _Component);

  function VerticalCurtain() {
    (0, _classCallCheck3.default)(this, VerticalCurtain);
    return (0, _possibleConstructorReturn3.default)(this, (VerticalCurtain.__proto__ || (0, _getPrototypeOf2.default)(VerticalCurtain)).apply(this, arguments));
  }

  (0, _createClass3.default)(VerticalCurtain, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.animate();
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var className = ['vertical-curtain'];
      if (this.props.classNamePrefix) {
        className.push(this.props.classNamePrefix + '__vertical-curtain');
      }
      if (this.props.className) {
        className.push(this.props.className);
      }
      return _react2.default.createElement(
        'clipPath',
        {
          id: this.props.id,
          className: className.join(' ')
        },
        _react2.default.createElement('rect', {
          transform: 'translate(0,' + this.props.areaHeight + ')',
          ref: function ref(n) {
            return _this2.rect = n;
          },
          width: this.props.areaWidth,
          height: 0
        })
      );
    }
  }, {
    key: 'animate',
    value: function animate() {
      var ease = _lodash2.default.isFunction(this.props.ease) ? this.props.ease : d3Eases[this.props.ease];
      var transition = (0, _d3Transition.transition)().duration(this.props.duration).delay(this.props.delay).ease(ease);
      var rectSelection = (0, _d3Selection.select)(this.rect);
      var rectHeight = parseFloat(rectSelection.attr('height') || 0);
      if (this.props.areaHeight && this.props.areaHeight !== rectHeight) {
        rectSelection.transition(transition).attr('height', this.props.areaHeight).attr('transform', 'translate(0,0)');
      }
    }
  }]);
  return VerticalCurtain;
}(_react.Component);

VerticalCurtain.propTypes = {
  id: _propTypes2.default.string,
  className: _propTypes2.default.string,
  classNamePrefix: _propTypes2.default.string,
  height: _propTypes2.default.number,
  areaHeight: _propTypes2.default.number,
  areaWidth: _propTypes2.default.number,
  paddingBottom: _propTypes2.default.number,
  paddingLeft: _propTypes2.default.number,
  paddingRight: _propTypes2.default.number,
  paddingTop: _propTypes2.default.number,
  duration: _propTypes2.default.number,
  delay: _propTypes2.default.number,
  ease: _customPropTypes.stringOrFunc
};
VerticalCurtain.defaultProps = {
  delay: 0,
  duration: 300,
  ease: _d3Ease.easePolyInOut
};
var _default = VerticalCurtain;
exports.default = _default;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(d3Eases, 'd3Eases', 'src/animators/VerticalCurtain.js');

  __REACT_HOT_LOADER__.register(VerticalCurtain, 'VerticalCurtain', 'src/animators/VerticalCurtain.js');

  __REACT_HOT_LOADER__.register(_default, 'default', 'src/animators/VerticalCurtain.js');
}();

;