'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _d3Selection = require('d3-selection');

var _d3Axis = require('d3-axis');

var _reactAddonsShallowCompare = require('react-addons-shallow-compare');

var _reactAddonsShallowCompare2 = _interopRequireDefault(_reactAddonsShallowCompare);

var _customPropTypes = require('../propTypes/customPropTypes');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var AxisBottom = function (_Component) {
  (0, _inherits3.default)(AxisBottom, _Component);

  function AxisBottom() {
    (0, _classCallCheck3.default)(this, AxisBottom);
    return (0, _possibleConstructorReturn3.default)(this, (AxisBottom.__proto__ || (0, _getPrototypeOf2.default)(AxisBottom)).apply(this, arguments));
  }

  (0, _createClass3.default)(AxisBottom, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.renderAxis();
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate() {
      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return _reactAddonsShallowCompare2.default.apply(undefined, [this].concat(args));
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      this.renderAxis();
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var className = ['axis-bottom'];
      if (this.props.classNamePrefix) {
        className.push(this.props.classNamePrefix + '__axis-bottom');
      }
      if (this.props.className) {
        className.push(this.props.className);
      }
      return _react2.default.createElement('g', {
        className: className.join(' '),
        transform: 'translate(' + this.props.paddingLeft + ',' + (this.props.height - this.props.paddingBottom) + ')',
        ref: function ref(node) {
          return _this2.node = node;
        }
      });
    }
  }, {
    key: 'renderAxis',
    value: function renderAxis() {
      if (this.props.DEBUG) {
        /* eslint-disable no-console */
        console.log('AxisBottom::renderAxis', this.props);
      }
      this.group = (0, _d3Selection.select)(this.node);
      if (!this.props.chartData) {
        this.group.selectAll('.tick').remove();
        return;
      }
      var axis = (0, _d3Axis.axisBottom)(this.props.xScale);
      if (this.props.breakPoint) {
        if (this.props.width < this.props.breakPoint) {
          // Cut number of ticks in half,
          if (!this.props.xScale.ticks) {
            // Handle scaleBand, ie - BasicFunnelChart
            axis.tickValues(this.props.xScale.domain().filter(function (d, i) {
              return i % 2 === 0;
            }));
          } else {
            // Handle scaleOrdinal
            // get odds so last entry remains on scale, looks nicer
            axis.tickValues(this.props.xScale.ticks().filter(function (d, i) {
              return i % 2 !== 0;
            }));
          }
        }
      }
      if (this.props.ticksFilter) {
        if (this.props.xScale.ticks) {
          axis.tickValues(this.props.ticksFilter(this.props.xScale.ticks()));
        } else if (this.props.xScale.domain) {
          axis.tickValues(this.props.ticksFilter(this.props.xScale.domain()));
        }
      }
      if (this.props.tickFormat) {
        axis.tickFormat(this.props.tickFormat);
      }
      if (this.props.chartData.length && this.node) {
        this.group.call(axis);
        var texts = this.group.selectAll('text');
        if (this.props.textTransform) {
          texts.attr('transform', this.props.textTransform);
        }
        if (this.props.textDy) {
          texts.attr('dy', this.props.textDy);
        }
        if (this.props.textDx) {
          texts.attr('dx', this.props.textDx);
        }
        if (this.props.customLabel) {
          var bbox = this.node.getBBox();
          var axisWidth = bbox.width;
          var labelFn = this.props.customLabel;
          texts.text(function iterator(d, i, items) {
            var stepWidth = axisWidth / items.length;
            return labelFn(d, i, stepWidth, this);
          });
        }
      }
    }
  }]);
  return AxisBottom;
}(_react.Component);

AxisBottom.propTypes = {
  chartData: _propTypes2.default.array,
  className: _propTypes2.default.string,
  classNamePrefix: _propTypes2.default.string,
  customLabel: _propTypes2.default.func,
  xScale: _propTypes2.default.func,
  size: _propTypes2.default.number,
  height: _propTypes2.default.number,
  paddingLeft: _propTypes2.default.number,
  paddingBottom: _propTypes2.default.number,
  paddingRight: _propTypes2.default.number,
  paddingTop: _propTypes2.default.number,
  textTransform: _customPropTypes.stringOrFunc,
  textDy: _customPropTypes.stringOrFunc,
  textDx: _customPropTypes.stringOrFunc,
  tickFormat: _customPropTypes.stringOrFunc,
  ticksFilter: _propTypes2.default.func,
  breakPoint: _propTypes2.default.number,
  width: _propTypes2.default.number,
  DEBUG: _propTypes2.default.bool
};
AxisBottom.defaultProps = {
  size: 20
};
var _default = AxisBottom;
exports.default = _default;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(AxisBottom, 'AxisBottom', 'src/axes/AxisBottom.js');

  __REACT_HOT_LOADER__.register(_default, 'default', 'src/axes/AxisBottom.js');
}();

;