'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _d3Selection = require('d3-selection');

var _d3Axis = require('d3-axis');

var _d3Format = require('d3-format');

var _reactAddonsShallowCompare = require('react-addons-shallow-compare');

var _reactAddonsShallowCompare2 = _interopRequireDefault(_reactAddonsShallowCompare);

var _customPropTypes = require('../propTypes/customPropTypes');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var AxisLeft = function (_Component) {
  (0, _inherits3.default)(AxisLeft, _Component);

  function AxisLeft() {
    (0, _classCallCheck3.default)(this, AxisLeft);
    return (0, _possibleConstructorReturn3.default)(this, (AxisLeft.__proto__ || (0, _getPrototypeOf2.default)(AxisLeft)).apply(this, arguments));
  }

  (0, _createClass3.default)(AxisLeft, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.renderAxis();
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate() {
      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return _reactAddonsShallowCompare2.default.apply(undefined, [this].concat(args));
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      this.renderAxis();
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var className = ['axis-left'];
      if (this.props.classNamePrefix) {
        className.push(this.props.classNamePrefix + '__axis-left');
      }
      if (this.props.className) {
        className.push(this.props.className);
      }
      return _react2.default.createElement('g', { className: className.join(' '), ref: function ref(n) {
          return _this2.node = n;
        } });
    }
  }, {
    key: 'renderAxis',
    value: function renderAxis() {
      var _props = this.props,
          paddingLeft = _props.paddingLeft,
          paddingTop = _props.paddingTop,
          tickFormat = _props.tickFormat,
          ticksFilter = _props.ticksFilter,
          yScale = _props.yScale;

      var maxValue = yScale.domain()[1];
      var numValues = maxValue - yScale.domain()[0];
      var axis = (0, _d3Axis.axisLeft)(yScale);
      if (ticksFilter) {
        axis.tickValues(ticksFilter(yScale.ticks()));
      }
      if (tickFormat) {
        axis.tickFormat(tickFormat);
      } else if (maxValue >= 1000) {
        axis.tickFormat((0, _d3Format.format)('.2s'));
      }
      if (numValues < 10) {
        axis.ticks(numValues);
      }
      this.group = (0, _d3Selection.select)(this.node);
      this.group.call(axis);
      var yAxisOffset = paddingLeft;
      this.group.attr('transform', 'translate(' + yAxisOffset + ',' + paddingTop + ')');
    }
  }]);
  return AxisLeft;
}(_react.Component);

AxisLeft.propTypes = {
  className: _propTypes2.default.string,
  classNamePrefix: _propTypes2.default.string,
  yScale: _propTypes2.default.func,
  size: _propTypes2.default.number,
  height: _propTypes2.default.number,
  paddingLeft: _propTypes2.default.number,
  paddingBottom: _propTypes2.default.number,
  paddingRight: _propTypes2.default.number,
  paddingTop: _propTypes2.default.number,
  tickFormat: _customPropTypes.stringOrFunc,
  ticksFilter: _propTypes2.default.func
};
AxisLeft.defaultProps = {
  size: 20
};
var _default = AxisLeft;
exports.default = _default;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(AxisLeft, 'AxisLeft', 'src/axes/AxisLeft.js');

  __REACT_HOT_LOADER__.register(_default, 'default', 'src/axes/AxisLeft.js');
}();

;