'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _d3Selection = require('d3-selection');

var _d3Axis = require('d3-axis');

var _customPropTypes = require('../propTypes/customPropTypes');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var AxisRight = function (_Component) {
  (0, _inherits3.default)(AxisRight, _Component);

  function AxisRight() {
    (0, _classCallCheck3.default)(this, AxisRight);
    return (0, _possibleConstructorReturn3.default)(this, (AxisRight.__proto__ || (0, _getPrototypeOf2.default)(AxisRight)).apply(this, arguments));
  }

  (0, _createClass3.default)(AxisRight, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.renderAxis();
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      this.renderAxis();
    }
  }, {
    key: 'getYScale',
    value: function getYScale() {
      if (this.props.customYScaleDomain) {
        if (this.props.DEBUG) {
          /* eslint-disable no-console */
          console.debug('AxisRight custom y scale domain passed, using a different domain than parent Chart');
        }
        return this.props.yScale.copy().domain(this.props.customYScaleDomain);
      } else {
        return this.props.yScale;
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var className = ['axis-right'];
      if (this.props.classNamePrefix) {
        className.push(this.props.classNamePrefix + '__axis-right');
      }
      if (this.props.className) {
        className.push(this.props.className);
      }
      return _react2.default.createElement('g', { className: className.join(' '), opacity: this.props.opacity, ref: function ref(n) {
          return _this2.node = n;
        } });
    }
  }, {
    key: 'renderAxis',
    value: function renderAxis() {
      var yScale = this.getYScale();
      var axis = (0, _d3Axis.axisRight)(yScale);
      if (this.props.ticksFilter) {
        axis.tickValues(this.props.ticksFilter(yScale.ticks()));
      }
      if (this.props.tickFormat) {
        axis.tickFormat(this.props.tickFormat);
      }
      this.group = (0, _d3Selection.select)(this.node);
      this.group.call(axis);
      var yAxisOffset = this.props.width - this.props.paddingRight;
      this.group.attr('transform', 'translate(' + yAxisOffset + ',' + this.props.paddingTop + ')');
      if (this.props.tickTextColor) {
        this.group.selectAll('.tick text').style('fill', this.props.tickTextColor);
      }
    }
  }]);
  return AxisRight;
}(_react.Component);

AxisRight.propTypes = {
  DEBUG: _propTypes2.default.bool,
  className: _propTypes2.default.string,
  classNamePrefix: _propTypes2.default.string,
  yScale: _propTypes2.default.func,
  customYScaleDomain: _propTypes2.default.array,
  size: _propTypes2.default.number,
  height: _propTypes2.default.number,
  width: _propTypes2.default.number,
  opacity: _propTypes2.default.number,
  paddingLeft: _propTypes2.default.number,
  paddingBottom: _propTypes2.default.number,
  paddingRight: _propTypes2.default.number,
  paddingTop: _propTypes2.default.number,
  tickFormat: _customPropTypes.stringOrFunc,
  ticksFilter: _propTypes2.default.func,
  tickTextColor: _propTypes2.default.string
};
AxisRight.defaultProps = {
  size: 20,
  opacity: 1
};
var _default = AxisRight;
exports.default = _default;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(AxisRight, 'AxisRight', 'src/axes/AxisRight.js');

  __REACT_HOT_LOADER__.register(_default, 'default', 'src/axes/AxisRight.js');
}();

;