'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _d3Selection = require('d3-selection');

var _d3Axis = require('d3-axis');

var _customPropTypes = require('../propTypes/customPropTypes');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var AxisTop = function (_Component) {
  (0, _inherits3.default)(AxisTop, _Component);

  function AxisTop() {
    (0, _classCallCheck3.default)(this, AxisTop);
    return (0, _possibleConstructorReturn3.default)(this, (AxisTop.__proto__ || (0, _getPrototypeOf2.default)(AxisTop)).apply(this, arguments));
  }

  (0, _createClass3.default)(AxisTop, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.renderAxis();
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      this.renderAxis();
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var className = ['axis-top'];
      if (this.props.classNamePrefix) {
        className.push(this.props.classNamePrefix + '__axis-top');
      }
      if (this.props.className) {
        className.push(this.props.className);
      }
      return _react2.default.createElement('g', {
        className: className.join(' '),
        transform: 'translate(' + this.props.paddingLeft + ',' + this.props.paddingTop + ')',
        ref: function ref(node) {
          return _this2.node = node;
        }
      });
    }
  }, {
    key: 'renderAxis',
    value: function renderAxis() {
      var axis = (0, _d3Axis.axisTop)(this.props.xScale);
      if (this.props.ticksFilter) {
        axis.tickValues(this.props.ticksFilter(this.props.xScale.ticks()));
      }
      if (this.props.tickFormat) {
        axis.tickFormat(this.props.tickFormat);
      }
      this.group = (0, _d3Selection.select)(this.node);
      this.group.call(axis);
      var texts = this.group.selectAll('text');
      if (this.props.textTransform) {
        texts.attr('transform', this.props.textTransform);
      }
      if (this.props.textDy) {
        texts.attr('dy', this.props.textDy);
      }
      if (this.props.textDx) {
        texts.attr('dx', this.props.textDx);
      }
    }
  }]);
  return AxisTop;
}(_react.Component);

AxisTop.propTypes = {
  className: _propTypes2.default.string,
  classNamePrefix: _propTypes2.default.string,
  xScale: _propTypes2.default.func,
  size: _propTypes2.default.number,
  height: _propTypes2.default.number,
  paddingLeft: _propTypes2.default.number,
  paddingBottom: _propTypes2.default.number,
  paddingRight: _propTypes2.default.number,
  paddingTop: _propTypes2.default.number,
  textTransform: _customPropTypes.stringOrFunc,
  textDy: _customPropTypes.stringOrFunc,
  textDx: _customPropTypes.stringOrFunc,
  tickFormat: _customPropTypes.stringOrFunc,
  ticksFilter: _propTypes2.default.func
};
AxisTop.defaultProps = {
  size: 20
};
var _default = AxisTop;
exports.default = _default;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(AxisTop, 'AxisTop', 'src/axes/AxisTop.js');

  __REACT_HOT_LOADER__.register(_default, 'default', 'src/axes/AxisTop.js');
}();

;