'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _d3Selection = require('d3-selection');

var _d3Axis = require('d3-axis');

var _customPropTypes = require('../propTypes/customPropTypes');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var HorizontalGrid = function (_Component) {
  (0, _inherits3.default)(HorizontalGrid, _Component);

  function HorizontalGrid() {
    (0, _classCallCheck3.default)(this, HorizontalGrid);
    return (0, _possibleConstructorReturn3.default)(this, (HorizontalGrid.__proto__ || (0, _getPrototypeOf2.default)(HorizontalGrid)).apply(this, arguments));
  }

  (0, _createClass3.default)(HorizontalGrid, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.renderGrid();
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      this.renderGrid();
    }
  }, {
    key: 'getClassNames',
    value: function getClassNames() {
      var className = ['horizontal-grid'];
      if (this.props.classNamePrefix) {
        className.push(this.props.classNamePrefix + '__horizontal-grid');
      }
      if (this.props.className) {
        className.push(this.props.className);
      }
      return className.join(' ');
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      return _react2.default.createElement('g', {
        className: this.getClassNames(),
        ref: function ref(n) {
          return _this2.node = (0, _d3Selection.select)(n);
        },
        transform: 'translate(' + this.props.paddingLeft + ', ' + this.props.paddingTop + ')'
      });
    }
  }, {
    key: 'renderGrid',
    value: function renderGrid() {
      var grid = (0, _d3Axis.axisLeft)(this.props.yScale).tickSize(-this.props.areaWidth).tickFormat('');

      if (this.props.ticks) {
        grid.ticks(this.props.ticks);
      }

      this.node.call(grid);
    }
  }]);
  return HorizontalGrid;
}(_react.Component);

HorizontalGrid.propTypes = {
  className: _propTypes2.default.string,
  classNamePrefix: _propTypes2.default.string,
  yScale: _propTypes2.default.func,
  xScale: _propTypes2.default.func,
  areaHeight: _propTypes2.default.number,
  areaWidth: _propTypes2.default.number,
  paddingLeft: _propTypes2.default.number,
  paddingBottom: _propTypes2.default.number,
  paddingRight: _propTypes2.default.number,
  paddingTop: _propTypes2.default.number,
  ticks: _customPropTypes.arrayOrFunc
};
var _default = HorizontalGrid;
exports.default = _default;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(HorizontalGrid, 'HorizontalGrid', 'src/axes/HorizontalGrid.js');

  __REACT_HOT_LOADER__.register(_default, 'default', 'src/axes/HorizontalGrid.js');
}();

;