'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _d3Selection = require('d3-selection');

var _d3Array = require('d3-array');

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _curryThisElement = require('../helpers/curryThisElement');

var _curryThisElement2 = _interopRequireDefault(_curryThisElement);

var _tooltipPositioner = require('../helpers/tooltipPositioner');

var _tooltipPositioner2 = _interopRequireDefault(_tooltipPositioner);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var VerticalHoverBar = function (_Component) {
  (0, _inherits3.default)(VerticalHoverBar, _Component);

  function VerticalHoverBar() {
    var _ref;

    (0, _classCallCheck3.default)(this, VerticalHoverBar);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    var _this = (0, _possibleConstructorReturn3.default)(this, (_ref = VerticalHoverBar.__proto__ || (0, _getPrototypeOf2.default)(VerticalHoverBar)).call.apply(_ref, [this].concat(args)));

    _this.state = {};
    _this.onMouseOver = (0, _curryThisElement2.default)(_this.onMouseOver, _this);
    _this.onMouseMove = (0, _curryThisElement2.default)(_this.onMouseMove, _this);
    _this.onMouseOut = (0, _curryThisElement2.default)(_this.onMouseOut, _this);
    return _this;
  }

  (0, _createClass3.default)(VerticalHoverBar, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.setupEvents();
      this.cacheData();
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      this.cacheData();
      this.renderTooltip();
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.hideTooltip();
      var ownerSVGElement = (0, _d3Selection.select)(this.bar.node().ownerSVGElement);
      ownerSVGElement.on('mouseover.VerticalHoverBar', null);
      ownerSVGElement.on('mousemove.VerticalHoverBar', null);
      ownerSVGElement.on('mouseout.VerticalHoverBar', null);
    }
  }, {
    key: 'onMouseOver',
    value: function onMouseOver(element) {
      this.updateHighlightBar(element);
    }
  }, {
    key: 'onMouseMove',
    value: function onMouseMove(element) {
      this.updateHighlightBar(element);
    }
  }, {
    key: 'onMouseOut',
    value: function onMouseOut(element) {
      this.hideHighlightBar(element);
      this.hideTooltip();
    }
  }, {
    key: 'getTooltipContainer',
    value: function getTooltipContainer() {
      if (!this.tooltipContainer) {
        this.tooltipContainer = window.document.createElement('div');
        this.tooltipContainer.className = this.props.tooltipClassName;
      }
      return this.tooltipContainer;
    }
  }, {
    key: 'setupEvents',
    value: function setupEvents() {
      var ownerSVGElement = (0, _d3Selection.select)(this.bar.node().ownerSVGElement);
      ownerSVGElement.on('mouseover.VerticalHoverBar', this.onMouseOver);
      ownerSVGElement.on('mousemove.VerticalHoverBar', this.onMouseMove);
      ownerSVGElement.on('mouseout.VerticalHoverBar', this.onMouseOut);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var className = ['vertical-hover-bar'];
      if (this.props.classNamePrefix) {
        className.push(this.props.classNamePrefix + '__vertical-hover-bar');
      }
      if (this.props.className) {
        className.push(this.props.className);
      }
      var transform = void 0;
      if (this.state.xTranslate !== undefined) {
        transform = 'translate(' + this.state.xTranslate + ',0)';
      }
      return _react2.default.createElement(
        'g',
        {
          className: className.join(' '),
          transform: 'translate(' + this.props.paddingLeft + ',' + this.props.paddingTop + ')'
        },
        _react2.default.createElement('rect', {
          height: this.props.areaHeight,
          width: this.props.barWidth,
          className: 'vertical-hover-bar__bar',
          style: {
            pointerEvents: 'none',
            display: this.state.xTranslate ? '' : 'none'
          },
          filter: this.props.filter,
          transform: transform,
          ref: function ref(n) {
            return _this2.bar = (0, _d3Selection.select)(n);
          }
        })
      );
    }
  }, {
    key: 'renderTooltip',
    value: function renderTooltip() {
      if (this.state.data && _react2.default.Children.count(this.props.children)) {
        var child = _react2.default.Children.only(this.props.children);
        var container = this.getTooltipContainer();
        if (!container.parentNode) {
          window.document.body.appendChild(container);
        }
        _reactDom2.default.render(_react2.default.cloneElement(child, (0, _extends3.default)({}, this.props, child.props, {
          children: child.props.children,
          data: this.state.data
        })), container);
        (0, _tooltipPositioner2.default)(child.props.position, this.bar.node(), container, child.props);
      } else {
        this.hideTooltip();
      }
    }
  }, {
    key: 'updateHighlightBar',
    value: function updateHighlightBar(mouseEvent) {
      var mouse = (0, _d3Selection.mouse)(mouseEvent);
      mouse[0] -= this.props.paddingLeft;
      mouse[1] -= this.props.paddingTop;
      var x0 = this.props.xScale.invert(mouse[0]);
      var bisected = (0, _d3Array.bisectLeft)(this.flattenedXValues, x0);
      var leftData = this.flattenedChartData[bisected - 1];
      var rightData = this.flattenedChartData[bisected];
      var data = leftData || rightData;
      if (leftData && rightData) {
        data = x0 - leftData.xValue > rightData.xValue - x0 ? rightData : leftData;
      }
      if (data) {
        var xTranslate = this.props.xScale(data.xValue) - this.props.barWidth / 2;
        this.setState({
          xTranslate: xTranslate,
          data: data
        });
      } else {
        this.hideHighlightBar();
        this.hideTooltip();
      }
    }
  }, {
    key: 'hideHighlightBar',
    value: function hideHighlightBar() {
      this.setState({
        xTranslate: undefined,
        data: undefined
      });
    }
  }, {
    key: 'hideTooltip',
    value: function hideTooltip() {
      if (this.tooltipContainer && this.tooltipContainer.parentNode) {
        this.tooltipContainer.parentNode.removeChild(this.tooltipContainer);
        delete this.tooltipContainer;
      }
    }
  }, {
    key: 'cacheData',
    value: function cacheData() {
      this.flattenedChartData = _lodash2.default.flatten(this.props.chartData).filter(function (a) {
        return a.xValue !== undefined;
      });
      this.flattenedChartData.sort(function (a, b) {
        return a.xValue - b.xValue;
      });
      this.flattenedXValues = (this.flattenedChartData || []).map(function (d) {
        return d.xValue;
      });
    }
  }]);
  return VerticalHoverBar;
}(_react.Component);

VerticalHoverBar.propTypes = {
  className: _propTypes2.default.string,
  chartData: _propTypes2.default.array,
  classNamePrefix: _propTypes2.default.string,
  paddingTop: _propTypes2.default.number,
  paddingLeft: _propTypes2.default.number,
  xScale: _propTypes2.default.func,
  yScale: _propTypes2.default.func,
  areaWidth: _propTypes2.default.number,
  areaHeight: _propTypes2.default.number,
  barWidth: _propTypes2.default.number,
  filter: _propTypes2.default.string,
  location: _propTypes2.default.symbol,
  children: _propTypes2.default.node,
  tooltipClassName: _propTypes2.default.string
};
VerticalHoverBar.defaultProps = {
  barWidth: 2,
  tooltipClassName: 'tooltip'
};
var _default = VerticalHoverBar;
exports.default = _default;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(VerticalHoverBar, 'VerticalHoverBar', 'src/axes/VerticalHoverBar.js');

  __REACT_HOT_LOADER__.register(_default, 'default', 'src/axes/VerticalHoverBar.js');
}();

;