'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _d3Shape = require('d3-shape');

var _d3Selection = require('d3-selection');

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _asURLFragment = require('../helpers/asURLFragment');

var _asURLFragment2 = _interopRequireDefault(_asURLFragment);

var _valueOf = require('../helpers/valueOf');

var _valueOf2 = _interopRequireDefault(_valueOf);

var _TransitionBase2 = require('../helpers/TransitionBase');

var _TransitionBase3 = _interopRequireDefault(_TransitionBase2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var stringOrArrayOfStrings = _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.arrayOf(_propTypes2.default.string)]);

var AreaChart = function (_TransitionBase) {
  (0, _inherits3.default)(AreaChart, _TransitionBase);

  function AreaChart() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, AreaChart);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = AreaChart.__proto__ || (0, _getPrototypeOf2.default)(AreaChart)).call.apply(_ref, [this].concat(args))), _this), _initialiseProps.call(_this), _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(AreaChart, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.curveType = this.props.curveType === 'curve' ? _d3Shape.curveMonotoneX : _d3Shape.curveLinear;
      this.renderArea();
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      this.curveType = this.props.curveType === 'curve' ? _d3Shape.curveMonotoneX : _d3Shape.curveLinear;
      this.renderArea();
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var className = ['area-chart'];
      if (this.props.classNamePrefix) {
        className.push(this.props.classNamePrefix + '__area-chart');
      }
      if (this.props.className) {
        className.push(this.props.className);
      }
      return _react2.default.createElement('g', {
        className: className.join(' '),
        transform: 'translate(' + this.props.paddingLeft + ',' + this.props.paddingTop + ')',
        clipPath: this.props.clipPath,
        ref: function ref(n) {
          return _this2.node = (0, _d3Selection.select)(n);
        }
      });
    }
  }, {
    key: 'renderArea',
    value: function renderArea() {
      var _this3 = this;

      var enterAreaGenerator = (0, _d3Shape.area)().x(function (d) {
        return _this3.props.xScale(d.xValue);
      }).y1(function () {
        return _this3.props.yScale(_this3.props.yScale.domain()[0]);
      }).y0(function () {
        return _this3.props.areaHeight;
      }).curve(this.curveType);
      var areaGenerator = (0, _d3Shape.area)().x(function (d) {
        return _this3.props.xScale(d.xValue);
      }).y1(function (d) {
        return _this3.props.yScale(d.yValue || 0);
      }).y0(this.getYZeroPosition).curve(this.curveType);

      var paths = this.node.selectAll('.area-chart__area').data(this.props.chartData, this.getUniqueDataKey);

      paths.exit().call(this.applyTransition, function (selection) {
        return selection.attr('d', enterAreaGenerator).remove();
      });

      paths.enter().append('path').attr('class', 'area-chart__area').attr('d', enterAreaGenerator).merge(paths).style('fill', this.getFillColor).style('filter', this.getPathFilter).attr('mask', this.getPathMask).call(this.applyTransition, function (selection) {
        return selection.attr('d', areaGenerator);
      });
    }
  }]);
  return AreaChart;
}(_TransitionBase3.default);

AreaChart.propTypes = (0, _extends3.default)({
  chartData: _propTypes2.default.array,
  className: _propTypes2.default.string,
  classNamePrefix: _propTypes2.default.string,
  colorPalette: _propTypes2.default.any,
  curveType: _propTypes2.default.string,
  fill: _propTypes2.default.string,
  filter: stringOrArrayOfStrings,
  layout: _propTypes2.default.string,
  mask: stringOrArrayOfStrings,
  paddingBottom: _propTypes2.default.number,
  paddingLeft: _propTypes2.default.number,
  paddingRight: _propTypes2.default.number,
  paddingTop: _propTypes2.default.number,
  valueKeys: _propTypes2.default.array,
  xScale: _propTypes2.default.func,
  yScale: _propTypes2.default.func,
  height: _propTypes2.default.number,
  areaHeight: _propTypes2.default.number,
  clipPath: _propTypes2.default.string
}, _TransitionBase3.default.propTypes);
AreaChart.defaultProps = (0, _extends3.default)({
  curveType: 'linear'
}, _TransitionBase3.default.defaultProps);

var _initialiseProps = function _initialiseProps() {
  var _this4 = this;

  this.getFillColor = function (d, i) {
    if (_this4.props.colorPalette) {
      if (_lodash2.default.isFunction(_this4.props.colorPalette)) {
        return _this4.props.colorPalette(i);
      }
      return _this4.props.colorPalette[i];
    }
    return (0, _valueOf2.default)(_this4.props.fill, d, i);
  };

  this.getUniqueDataKey = function (dataSet, i) {
    return '' + _this4.props.valueKeys[i];
  };

  this.getPathFilter = function () {
    for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }

    var filter = _valueOf2.default.apply(undefined, [_this4.props.filter].concat(args));
    if (filter) {
      return (0, _asURLFragment2.default)(filter);
    }
    return undefined;
  };

  this.getPathMask = function () {
    for (var _len3 = arguments.length, args = Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
      args[_key3] = arguments[_key3];
    }

    var mask = _valueOf2.default.apply(undefined, [_this4.props.mask].concat(args));
    if (mask) {
      return (0, _asURLFragment2.default)(mask);
    }
    return undefined;
  };

  this.getYZeroPosition = function (d) {
    return _this4.props.layout === 'stack' ? _this4.props.yScale(d.y0Value || 0) : _this4.props.areaHeight;
  };
};

var _default = AreaChart;
exports.default = _default;
;

var _temp2 = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(stringOrArrayOfStrings, 'stringOrArrayOfStrings', 'src/charts/AreaChart.js');

  __REACT_HOT_LOADER__.register(AreaChart, 'AreaChart', 'src/charts/AreaChart.js');

  __REACT_HOT_LOADER__.register(_default, 'default', 'src/charts/AreaChart.js');
}();

;