'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _d3Selection = require('d3-selection');

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _customPropTypes = require('../propTypes/customPropTypes');

var _TooltipRenderer = require('../helpers/TooltipRenderer');

var _TooltipRenderer2 = _interopRequireDefault(_TooltipRenderer);

var _asURLFragment = require('../helpers/asURLFragment');

var _asURLFragment2 = _interopRequireDefault(_asURLFragment);

var _valueOf = require('../helpers/valueOf');

var _valueOf2 = _interopRequireDefault(_valueOf);

var _TransitionBase2 = require('../helpers/TransitionBase');

var _TransitionBase3 = _interopRequireDefault(_TransitionBase2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var BarChart = function (_TransitionBase) {
  (0, _inherits3.default)(BarChart, _TransitionBase);

  function BarChart() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, BarChart);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = BarChart.__proto__ || (0, _getPrototypeOf2.default)(BarChart)).call.apply(_ref, [this].concat(args))), _this), _initialiseProps.call(_this), _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(BarChart, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.tooltipRenderer = new _TooltipRenderer2.default(this);
      this.node.call(this.tooltipRenderer.bind);
      if (this.hasTooltip()) {
        this.tooltipRenderer.update(_react2.default.Children.only(this.props.children));
      }
      this.renderChart();
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      this.renderChart();
      if (this.hasTooltip()) {
        this.tooltipRenderer.update(_react2.default.Children.only(this.props.children));
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var className = ['bar-chart'];
      if (this.props.classNamePrefix) {
        className.push(this.props.classNamePrefix + '__bar-chart');
      }
      if (this.props.className) {
        className.push(this.props.className);
      }
      return _react2.default.createElement('g', {
        className: className.join(' '),
        ref: function ref(n) {
          return _this2.node = (0, _d3Selection.select)(n);
        },
        transform: 'translate(' + this.props.paddingLeft + ',' + this.props.paddingTop + ')',
        clipPath: this.props.clipPath
      });
    }
  }, {
    key: 'renderChart',
    value: function renderChart() {
      if (!this.props.xScale.bandwidth) {
        /* eslint-disable no-console */
        console.warn('BarChart\'s xScale needs to provide the bandwidth function. See d3.scaleBand');
        return;
      }

      var groups = this.node.selectAll('.bar-chart__group').data(this.props.chartData, this.getUniqueDataKey);

      groups.exit().remove();

      groups.enter().append('g').attr('class', 'bar-chart__group').merge(groups).style('fill', this.getGroupFillFromColorPalette).attr('mask', this.getPathMask);
      this.renderGroupedBars();
      this.renderTooltips();
      this.enableClickEvents();
    }
  }, {
    key: 'renderGroupedBars',
    value: function renderGroupedBars() {
      var _this3 = this;

      var xScale = this.props.xScale.copy();
      var bottomY = this.props.yScale(this.props.yScale.domain()[0]);
      xScale.range([0, this.props.xScale.bandwidth()]);
      xScale.domain(this.props.valueKeys);

      var groups = this.node.selectAll('.bar-chart__group');
      var bars = groups.selectAll('.bar-chart__group__bar').data(function (d) {
        return d;
      }, this.getUniqueItemKey);

      bars.exit().call(this.applyTransition, function (selection) {
        return selection.attr('y', bottomY).remove();
      });

      bars.enter().append('rect').attr('class', 'bar-chart__group__bar').attr('height', 0).attr('x', function (d) {
        return xScale(d.yKey) + _this3.props.xScale(d.xValue);
      }).style('fill', this.getBarFillFromColorPalette).attr('y', bottomY).merge(bars).attr('width', xScale.bandwidth()).style('filter', this.getFilter).call(this.applyTransition, function (selection) {
        return selection.attr('x', function (d) {
          return xScale(d.yKey) + _this3.props.xScale(d.xValue);
        }).attr('y', function (d) {
          return _this3.props.yScale(d.yValue || 0);
        }).attr('height', function (d) {
          return Math.max(_this3.props.areaHeight - _this3.props.yScale(d.yValue || 0), 0);
        });
      });

      if (this.props.lineThickness) {
        var rectHeight = this.props.lineThickness;
        var lines = groups.selectAll('.bar-chart__group__line').data(function (d) {
          return d;
        });

        lines.exit().remove();

        lines.enter().append('rect').attrs({
          x: function x(d) {
            return xScale(d.yKey) + _this3.props.xScale(d.xValue);
          },
          y: bottomY - (1 + rectHeight),
          width: xScale.bandwidth(),
          height: rectHeight,
          class: 'bar-chart__group__line',
          fill: this.getBarFillFromColorPalette
        }).merge(lines).call(this.applyTransition, function (selection) {
          return selection.attrs({
            x: function x(d) {
              return xScale(d.yKey) + _this3.props.xScale(d.xValue);
            },
            y: function y(d) {
              return bottomY - (_this3.props.areaHeight - _this3.props.yScale(d.yValue || 0)) - rectHeight;
            },
            width: xScale.bandwidth()
          });
        });
      }
    }
  }, {
    key: 'renderTooltips',
    value: function renderTooltips() {
      var bars = this.node.selectAll('.bar-chart__group').selectAll('.bar-chart__group__bar');
      if (this.hasTooltip()) {
        bars.on('mouseover.BarChart', this.tooltipRenderer.onShow);
        bars.on('mouseout.BarChart', this.tooltipRenderer.onHide);
        bars.on('mouseover.BarChartTooltip', this.onTooltipShow);
        bars.on('mouseout.BarChartTooltip', this.onTooltipHide);
        this.node.on('mousemove.BarChart', this.tooltipRenderer.onMove);
      } else {
        bars.on('mouseover.BarChart', null);
        bars.on('mouseout.BarChart', null);
        bars.on('mouseover.BarChartTooltip', null);
        bars.on('mouseout.BarChartTooltip', null);
        this.node.on('mousemove.BarChart', null);
      }

      var barlines = this.node.selectAll('.bar-chart__group').selectAll('.bar-chart__group__line');

      if (this.hasTooltip()) {
        barlines.on('mouseover.BarChartLine', this.tooltipRenderer.onShow);
        barlines.on('mouseout.BarChartLine', this.tooltipRenderer.onHide);
        barlines.on('mouseover.BarChartLineTooltip', this.onTooltipShow);
        barlines.on('mouseout.BarChartLineTooltip', this.onTooltipHide);
        this.node.on('mousemove.BarChartLine', this.tooltipRenderer.onMove);
      } else {
        barlines.on('mouseover.BarChartLine', null);
        barlines.on('mouseout.BarChartLine', null);
        barlines.on('mouseover.BarChartLineTooltip', null);
        barlines.on('mouseout.BarChartLineTooltip', null);
        this.node.on('mousemove.BarChartLine', null);
      }
    }
  }, {
    key: 'hasTooltip',
    value: function hasTooltip() {
      return _react2.default.Children.count(this.props.children) === 1;
    }
  }, {
    key: 'enableClickEvents',
    value: function enableClickEvents() {
      if (this.props.onElementClick) {
        this.node.selectAll('.bar-chart__group__bar').on('click.BarChart', this.onBarClick);
        this.node.selectAll('.bar-chart__group__line').on('click.BarChartLine', this.onBarClick);
      }
    }
  }]);
  return BarChart;
}(_TransitionBase3.default);

BarChart.propTypes = (0, _extends3.default)({
  areaHeight: _propTypes2.default.number,
  areaWidth: _propTypes2.default.number,
  chartData: _propTypes2.default.array,
  children: _propTypes2.default.node,
  className: _propTypes2.default.string,
  classNamePrefix: _propTypes2.default.string,
  clipPath: _propTypes2.default.string,
  groupColorPalette: _propTypes2.default.any,
  barColorPalette: _propTypes2.default.any,
  fill: _propTypes2.default.any,
  filter: _customPropTypes.stringOrArrayOfStrings,
  groupPadding: _propTypes2.default.any,
  lineThickness: _propTypes2.default.number,
  mask: _customPropTypes.stringOrArrayOfStrings,
  paddingBottom: _propTypes2.default.number,
  paddingLeft: _propTypes2.default.number,
  paddingRight: _propTypes2.default.number,
  paddingTop: _propTypes2.default.number,
  valueKeys: _propTypes2.default.array,
  xScale: _propTypes2.default.func,
  yScale: _propTypes2.default.func,
  onElementClick: _propTypes2.default.func,
  onTooltipShow: _propTypes2.default.func,
  onTooltipHide: _propTypes2.default.func
}, _TransitionBase3.default.propTypes);
BarChart.defaultProps = (0, _extends3.default)({
  fill: true,
  groupPadding: 0.1
}, _TransitionBase3.default.defaultProps);

var _initialiseProps = function _initialiseProps() {
  var _this4 = this;

  this.onTooltipShow = function (elementData) {
    if (_this4.props.onTooltipShow) {
      _this4.props.onTooltipShow(elementData.original);
    }
  };

  this.onTooltipHide = function (elementData) {
    if (_this4.props.onTooltipHide) {
      _this4.props.onTooltipHide(elementData.original);
    }
  };

  this.onBarClick = function (eventElement) {
    if (_this4.props.onElementClick) {
      _this4.props.onElementClick(eventElement.original);
    }
  };

  this.getGroupFillFromColorPalette = function (d, i) {
    return _this4.getFillFromColorPalette(_this4.props.groupColorPalette, d, i);
  };

  this.getBarFillFromColorPalette = function (d, i) {
    if (_this4.props.barColorPalette) {
      return _this4.getFillFromColorPalette(_this4.props.barColorPalette, d, i);
    }
    if (_this4.props.fill) {
      return (0, _valueOf2.default)(_this4.props.fill, d, i);
    }
    return undefined;
  };

  this.getFillFromColorPalette = function (colorPalette, d, i) {
    if (colorPalette) {
      if (_lodash2.default.isFunction(colorPalette)) {
        return colorPalette(i);
      } else if (_lodash2.default.isArray(colorPalette)) {
        return colorPalette[i];
      } else {
        return colorPalette;
      }
    }
    return undefined;
  };

  this.getUniqueDataKey = function (dataSet, i) {
    return '' + _this4.props.valueKeys[i];
  };

  this.getUniqueItemKey = function (datum, i) {
    return '' + (datum.xValue || i);
  };

  this.getFilter = function (d, i) {
    var filter = _this4.props.filter;
    if (_lodash2.default.isArray(filter)) {
      filter = filter[i];
    }
    if (filter) {
      return (0, _asURLFragment2.default)(filter);
    }
    return null;
  };

  this.getPathMask = function () {
    for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }

    var mask = _valueOf2.default.apply(undefined, [_this4.props.mask].concat(args));
    if (mask) {
      return (0, _asURLFragment2.default)(mask);
    }
    return null;
  };
};

var _default = BarChart;
exports.default = _default;
;

var _temp2 = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(BarChart, 'BarChart', 'src/charts/BarChart.js');

  __REACT_HOT_LOADER__.register(_default, 'default', 'src/charts/BarChart.js');
}();

;