'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _d3Selection = require('d3-selection');

var _d3Hierarchy = require('d3-hierarchy');

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _customPropTypes = require('../propTypes/customPropTypes');

var _asURLFragment = require('../helpers/asURLFragment');

var _asURLFragment2 = _interopRequireDefault(_asURLFragment);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var BubbleChart = function (_Component) {
  (0, _inherits3.default)(BubbleChart, _Component);

  function BubbleChart() {
    var _ref;

    (0, _classCallCheck3.default)(this, BubbleChart);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    var _this = (0, _possibleConstructorReturn3.default)(this, (_ref = BubbleChart.__proto__ || (0, _getPrototypeOf2.default)(BubbleChart)).call.apply(_ref, [this].concat(args)));

    _this.getColorPaletteFill = _this.getColorPaletteFill.bind(_this);
    _this.getPathFilter = _this.getPathFilter.bind(_this);
    return _this;
  }

  (0, _createClass3.default)(BubbleChart, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.renderBubbles();
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      this.renderBubbles();
    }
  }, {
    key: 'getColorPaletteFill',
    value: function getColorPaletteFill(d, i) {
      if (this.props.colorPalette) {
        if (_lodash2.default.isFunction(this.props.colorPalette)) {
          return this.props.colorPalette(d, i);
        } else {
          return this.props.colorPalette[i];
        }
      }
      return '';
    }
  }, {
    key: 'getPathFilter',
    value: function getPathFilter(d, i) {
      var filter = this.props.filter;
      if (_lodash2.default.isArray(filter)) {
        filter = filter[i];
      }
      return (0, _asURLFragment2.default)(filter);
    }
  }, {
    key: 'getCircleId',
    value: function getCircleId(d, i) {
      return 'circle-' + d.data.yKey + '-' + i;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var className = ['bubble-chart'];
      if (this.props.classNamePrefix) {
        className.push(this.props.classNamePrefix + '__bubble-chart');
      }
      if (this.props.className) {
        className.push(this.props.className);
      }
      return _react2.default.createElement('g', {
        className: className.join(' '),
        ref: function ref(n) {
          return _this2.node = n;
        },
        transform: 'translate(' + this.props.paddingLeft + ',' + this.props.paddingTop + ')',
        clipPath: this.props.clipPath
      });
    }
  }, {
    key: 'renderBubbles',
    value: function renderBubbles() {
      var packLayout = (0, _d3Hierarchy.pack)().size([this.props.areaWidth, this.props.areaHeight]).padding(this.props.packPadding);
      var hierarchy = (0, _d3Hierarchy.hierarchy)(this.transformedBubbleData()).sum(function (d) {
        return d.yValue;
      });
      var data = packLayout(hierarchy).children;
      this.group = (0, _d3Selection.select)(this.node);
      var enterBubbles = this.group.selectAll('.bubble-chart__bubble').data(data).enter().append('g').attr('class', 'bubble-chart__bubble');
      var updateBubbles = this.group.selectAll('.bubble-chart__bubble').attr('transform', function (d) {
        return 'translate(' + d.x + ',' + d.y + ')';
      });

      this.renderCircles(enterBubbles, updateBubbles);
      if (this.props.labelFormat) {
        this.renderLabels(enterBubbles, updateBubbles);
      }
    }
  }, {
    key: 'renderCircles',
    value: function renderCircles(enterBubbles, updateBubbles) {
      enterBubbles.append('circle').attr('class', 'bubble-chart__bubble__circle');
      var circles = updateBubbles.select('circle').attr('r', function (d) {
        return d.r;
      }).attr('id', this.getCircleId);
      if (this.props.colorPalette) {
        circles.style('fill', this.getColorPaletteFill);
      } else if (this.props.fillColor) {
        circles.style('fill', this.props.fillColor);
      } else {
        circles.style('fill', null);
      }
      if (this.props.filter) {
        circles.attr('filter', this.getPathFilter);
      } else {
        circles.attr('filter', null);
      }
    }
  }, {
    key: 'renderLabels',
    value: function renderLabels(enterBubbles, updateBubbles) {
      enterBubbles.append('text').attr('class', 'bubble-chart__bubble__label');
      var texts = updateBubbles.select('.bubble-chart__bubble__label').text(this.props.labelFormat);
      if (this.props.labelDx) {
        texts.attr('dx', this.props.labelDx);
      } else {
        texts.attr('dx', null);
      }
      if (this.props.labelDy) {
        texts.attr('dy', this.props.labelDy);
      } else {
        texts.attr('dy', null);
      }
    }
  }, {
    key: 'transformedBubbleData',
    value: function transformedBubbleData() {
      return {
        children: this.props.chartData[0].filter(function (d) {
          return d.yValue;
        })
      };
    }
  }]);
  return BubbleChart;
}(_react.Component);

BubbleChart.propTypes = {
  chartData: _propTypes2.default.array,
  className: _propTypes2.default.string,
  classNamePrefix: _propTypes2.default.string,
  colorPalette: _customPropTypes.arrayOrFunc,
  fillColor: _customPropTypes.arrayOrFunc,
  filter: _customPropTypes.stringOrArrayOfStrings,
  paddingBottom: _propTypes2.default.number,
  paddingLeft: _propTypes2.default.number,
  paddingRight: _propTypes2.default.number,
  paddingTop: _propTypes2.default.number,
  valueKeys: _propTypes2.default.array,
  xScale: _propTypes2.default.func,
  yScale: _propTypes2.default.func,
  clipPath: _propTypes2.default.string,
  packPadding: _customPropTypes.numberOrFunc,
  areaHeight: _propTypes2.default.number,
  areaWidth: _propTypes2.default.number,
  labelFormat: _propTypes2.default.func,
  labelDy: _customPropTypes.stringOrFunc,
  labelDx: _customPropTypes.stringOrFunc
};
BubbleChart.defaultProps = {
  packPadding: 1.5
};
var _default = BubbleChart;
exports.default = _default;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(BubbleChart, 'BubbleChart', 'src/charts/BubbleChart.js');

  __REACT_HOT_LOADER__.register(_default, 'default', 'src/charts/BubbleChart.js');
}();

;