'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _d3Selection = require('d3-selection');

var _d3Geo = require('d3-geo');

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _TooltipRenderer = require('../helpers/TooltipRenderer');

var _TooltipRenderer2 = _interopRequireDefault(_TooltipRenderer);

var _customPropTypes = require('../propTypes/customPropTypes');

var _asURLFragment = require('../helpers/asURLFragment');

var _asURLFragment2 = _interopRequireDefault(_asURLFragment);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ChoroplethMap = function (_Component) {
  (0, _inherits3.default)(ChoroplethMap, _Component);

  function ChoroplethMap() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, ChoroplethMap);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = ChoroplethMap.__proto__ || (0, _getPrototypeOf2.default)(ChoroplethMap)).call.apply(_ref, [this].concat(args))), _this), _this.onTooltipShow = function (eventElement) {
      if (_this.props.onTooltipShow) {
        _this.props.onTooltipShow(eventElement.data);
      }
    }, _this.onTooltipHide = function (eventElement) {
      if (_this.props.onTooltipHide) {
        _this.props.onTooltipHide(eventElement.data);
      }
    }, _this.onFeatureClick = function (eventElement) {
      _this.props.onElementClick(eventElement.data);
    }, _this.getPathGenerator = function () {
      return (0, _d3Geo.geoPath)().projection(_this.getProjection());
    }, _this.getProjection = function () {
      if (_lodash2.default.isFunction(_this.props.projection)) {
        return _this.props.projection(_this.props);
      }
      return _this.props.projection;
    }, _this.getPathFilter = function (d, i) {
      var filter = _this.props.filter;
      if (_lodash2.default.isFunction(filter)) {
        return filter;
      }
      if (_lodash2.default.isArray(filter)) {
        filter = filter[i];
      }
      if (filter) {
        return (0, _asURLFragment2.default)(filter);
      }
      return null;
    }, _this.getPathMask = function (d, i) {
      var mask = _this.props.mask;
      if (_lodash2.default.isArray(mask)) {
        mask = mask[i];
      }
      if (mask) {
        return (0, _asURLFragment2.default)(mask);
      }
      return null;
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(ChoroplethMap, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.tooltipRenderer = new _TooltipRenderer2.default(this);
      if (this.hasTooltip()) {
        this.tooltipRenderer.update(_react2.default.Children.only(this.props.children));
      }
      this.renderMap();
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      this.renderMap();
      if (this.hasTooltip()) {
        this.tooltipRenderer.update(_react2.default.Children.only(this.props.children));
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var className = ['choropleth-map'];
      if (this.props.classNamePrefix) {
        className.push(this.props.classNamePrefix + '__choropleth-map');
      }
      if (this.props.className) {
        className.push(this.props.className);
      }
      return _react2.default.createElement('g', {
        className: className.join(' '),
        transform: 'translate(' + this.props.paddingLeft + ',' + this.props.paddingTop + ')',
        ref: function ref(n) {
          return _this2.node = n;
        }
      });
    }
  }, {
    key: 'renderMap',
    value: function renderMap() {
      var group = (0, _d3Selection.select)(this.node);
      var features = group.selectAll('.choropleth-map__feature').data(this.generateTopology().features);
      features.enter().append('path').attr('class', this.props.cssClassName || 'choropleth-map__feature').merge(features).attr('d', this.getPathGenerator()).style('fill', this.props.fillColor).style('stroke', this.props.strokeColor).attr('mask', this.getPathMask).style('filter', this.getPathFilter);
      this.renderTooltip();
      this.enableClickEvents();
    }
  }, {
    key: 'renderTooltip',
    value: function renderTooltip() {
      var node = (0, _d3Selection.select)(this.node);
      var features = node.selectAll('.choropleth-map__feature');
      if (this.hasTooltip()) {
        node.call(this.tooltipRenderer.bind);
        features.on('mouseover.ChoroplethMap', this.tooltipRenderer.onShow);
        features.on('mouseout.ChoroplethMap', this.tooltipRenderer.onHide);
        features.on('mouseover.ChoroplethTooltip', this.onTooltipShow);
        features.on('mouseout.ChoroplethTooltip', this.onTooltipHide);
        node.on('mousemove.ChoroplethMap', this.tooltipRenderer.onMove);
      } else {
        features.on('mouseover.ChoroplethMap', null);
        features.on('mouseout.ChoroplethMap', null);
        features.on('mouseover.ChoroplethTooltip', null);
        features.on('mouseout.ChoroplethTooltip', null);
        node.on('mousemove.ChoroplethMap', null);
      }
    }
  }, {
    key: 'generateTopology',
    value: function generateTopology() {
      var _this3 = this;

      if (this.props.topologyMatcher) {
        var hashMap = this.generateChartDataHash();
        var features = this.props.topology.features.map(function (feature) {
          var key = _lodash2.default.get(feature, _this3.props.topologyMatcher);
          var data = hashMap[key];
          return (0, _extends3.default)({}, feature, {
            data: data
          });
        });
        return (0, _extends3.default)({}, this.props.topology, {
          features: features
        });
      }
      return this.props.topology;
    }
  }, {
    key: 'generateChartDataHash',
    value: function generateChartDataHash() {
      var hashMap = {};
      var first = _lodash2.default.first(this.props.chartData) || [];
      first.forEach(function (d) {
        return hashMap[d.xValue] = d;
      });
      return hashMap;
    }
  }, {
    key: 'hasTooltip',
    value: function hasTooltip() {
      return _react2.default.Children.count(this.props.children) === 1;
    }
  }, {
    key: 'enableClickEvents',
    value: function enableClickEvents() {
      if (this.props.onElementClick) {
        (0, _d3Selection.select)(this.node).selectAll('.choropleth-map__feature').on('click', this.onFeatureClick);
      }
    }
  }]);
  return ChoroplethMap;
}(_react.Component);

ChoroplethMap.propTypes = {
  chartData: _propTypes2.default.array,
  className: _propTypes2.default.string,
  classNamePrefix: _propTypes2.default.string,
  paddingBottom: _propTypes2.default.number,
  paddingLeft: _propTypes2.default.number,
  paddingRight: _propTypes2.default.number,
  paddingTop: _propTypes2.default.number,
  topology: _propTypes2.default.shape({
    features: _propTypes2.default.array.isRequired
  }),
  projection: _propTypes2.default.func,
  areaHeight: _propTypes2.default.number,
  areaWidth: _propTypes2.default.number,
  topologyMatcher: _propTypes2.default.string,
  fillColor: _propTypes2.default.any,
  strokeColor: _propTypes2.default.any,
  cssClassName: _propTypes2.default.any,
  children: _propTypes2.default.node,
  mask: _customPropTypes.stringOrFunc,
  filter: _customPropTypes.stringOrFunc,
  onElementClick: _propTypes2.default.func,
  onTooltipShow: _propTypes2.default.func,
  onTooltipHide: _propTypes2.default.func
};
ChoroplethMap.defaultProps = {};
var _default = ChoroplethMap;
exports.default = _default;
;

var _temp2 = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(ChoroplethMap, 'ChoroplethMap', 'src/charts/ChoroplethMap.js');

  __REACT_HOT_LOADER__.register(_default, 'default', 'src/charts/ChoroplethMap.js');
}();

;