'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _d3Selection = require('d3-selection');

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _customPropTypes = require('../propTypes/customPropTypes');

var _TooltipRenderer = require('../helpers/TooltipRenderer');

var _TooltipRenderer2 = _interopRequireDefault(_TooltipRenderer);

var _asURLFragment = require('../helpers/asURLFragment');

var _asURLFragment2 = _interopRequireDefault(_asURLFragment);

var _valueOf = require('../helpers/valueOf');

var _valueOf2 = _interopRequireDefault(_valueOf);

var _TransitionBase2 = require('../helpers/TransitionBase');

var _TransitionBase3 = _interopRequireDefault(_TransitionBase2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var FunnelChart = function (_TransitionBase) {
  (0, _inherits3.default)(FunnelChart, _TransitionBase);

  function FunnelChart() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, FunnelChart);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = FunnelChart.__proto__ || (0, _getPrototypeOf2.default)(FunnelChart)).call.apply(_ref, [this].concat(args))), _this), _this.onTooltipShow = function (elementData) {
      if (_this.props.onTooltipShow) {
        _this.props.onTooltipShow(elementData.original);
      }
    }, _this.onTooltipHide = function (elementData) {
      if (_this.props.onTooltipHide) {
        _this.props.onTooltipHide(elementData.original);
      }
    }, _this.getUniqueDataKey = function (dataSet, i) {
      return '' + _this.props.valueKeys[i];
    }, _this.getUniqueItemKey = function (datum, i) {
      return '' + (datum.xValue || i);
    }, _this.renderPiece = function (datum, index) {
      return _react2.default.createElement('rect', {
        key: 'piece-' + index,
        className: 'funnel-chart__piece',
        width: _this.props.xScale.bandwidth(),
        x: _this.props.xScale(datum.xValue),
        'data-id': 'piece-' + index
      });
    }, _this.renderGap = function (index) {
      return _react2.default.createElement('polygon', {
        key: 'gap-' + index,
        className: 'funnel-chart__gap',
        'data-id': 'gap-' + index
      });
    }, _this.animatePiece = function (datum, index) {
      var height = _this.yScale(datum.yValue || 0);
      var node = _this.node.select('[data-id="piece-' + index + '"]').datum(datum);
      node.attr('height', node.attr('height') || _this.props.minSize).attr('y', node.attr('y') || _this.props.areaHeight / 2 - _this.props.minSize / 2).style('fill', (0, _valueOf2.default)(_this.props.fill, datum, index)).style('stroke', (0, _valueOf2.default)(_this.props.stroke, datum, index)).call(_this.applyTransition, function (selection) {
        return selection.attr('height', height).attr('y', _this.props.areaHeight / 2 - height / 2);
      });

      if (_this.hasTooltip()) {
        node.on('mouseover.FunnelChart', _this.tooltipRenderer.onShow);
        node.on('mouseout.FunnelChart', _this.tooltipRenderer.onHide);
        node.on('mouseover.FunnelChartTooltip', _this.onTooltipShow);
        node.on('mouseout.FunnelChartTooltip', _this.onTooltipHide);
        _this.node.on('mousemove.FunnelChart', _this.tooltipRenderer.onMove);
      } else {
        node.on('mouseover.FunnelChart', null);
        node.on('mouseout.FunnelChart', null);
        node.on('mouseover.FunnelChartTooltip', null);
        node.on('mouseout.FunnelChartTooltip', null);
        _this.node.on('mousemove.FunnelChart', null);
      }
    }, _this.animateGaps = function (index) {
      var data = _this.getData();
      var left = data[index];
      var right = data[index + 1];
      var leftX = _this.props.xScale(left.xValue) + _this.props.xScale.bandwidth();
      var rightX = _this.props.xScale(right.xValue);
      var leftHeight = _this.yScale(left.yValue || 0);
      var rightHeight = _this.yScale(right.yValue || 0);
      var midPoint = _this.props.areaHeight / 2;
      var points = [leftX + ',' + (midPoint - leftHeight / 2), leftX + ',' + (midPoint + leftHeight / 2), rightX + ',' + (midPoint + rightHeight / 2), rightX + ',' + (midPoint - rightHeight / 2)];
      var startPoints = [leftX + ',' + midPoint, leftX + ',' + midPoint, rightX + ',' + midPoint, rightX + ',' + midPoint];
      var node = _this.node.select('[data-id="gap-' + index + '"]');
      node.attr('points', node.attr('points') || startPoints.join(' ')).style('fill', (0, _valueOf2.default)(_this.props.gapFill, left, index)).style('stroke', (0, _valueOf2.default)(_this.props.gapStroke, left, index)).call(_this.applyTransition, function (selection) {
        return selection.attr('points', points.join(' '));
      });
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(FunnelChart, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.tooltipRenderer = new _TooltipRenderer2.default(this);
      this.node.call(this.tooltipRenderer.bind);
      if (this.hasTooltip()) {
        this.tooltipRenderer.update(_react2.default.Children.only(this.props.children));
      }
      this.renderD3Visualization();
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      this.renderD3Visualization();
      if (this.hasTooltip()) {
        this.tooltipRenderer.update(_react2.default.Children.only(this.props.children));
      }
    }
  }, {
    key: 'getData',
    value: function getData() {
      return this.props.chartData[0] || [];
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var className = ['funnel-chart'];
      if (this.props.classNamePrefix) {
        className.push(this.props.classNamePrefix + '__funnel-chart');
      }
      if (this.props.className) {
        className.push(this.props.className);
      }
      this.yScale = this.props.yScale.copy();
      this.yScale.range([this.props.minSize, this.props.areaHeight]).clamp();
      return _react2.default.createElement(
        'g',
        {
          className: className.join(' '),
          ref: function ref(n) {
            return _this2.node = (0, _d3Selection.select)(n);
          },
          transform: 'translate(' + this.props.paddingLeft + ',' + this.props.paddingTop + ')',
          clipPath: this.props.clipPath,
          mask: (0, _asURLFragment2.default)(this.props.mask),
          style: { filter: (0, _asURLFragment2.default)(this.props.filter) }
        },
        this.renderFunnelGaps(),
        this.renderFunnelPieces()
      );
    }
  }, {
    key: 'renderFunnelPieces',
    value: function renderFunnelPieces() {
      return this.getData().map(this.renderPiece);
    }
  }, {
    key: 'renderFunnelGaps',
    value: function renderFunnelGaps() {
      var times = Math.max(this.getData().length - 1, 0);
      return _lodash2.default.times(times).map(this.renderGap);
    }
  }, {
    key: 'renderD3Visualization',
    value: function renderD3Visualization() {
      // this is hackery so the animation API is consistent between visualizations
      var data = this.getData();
      var times = Math.max(data.length - 1, 0);
      data.forEach(this.animatePiece);
      _lodash2.default.times(times).map(this.animateGaps);
    }
  }, {
    key: 'hasTooltip',
    value: function hasTooltip() {
      return _react2.default.Children.count(this.props.children) === 1;
    }
  }]);
  return FunnelChart;
}(_TransitionBase3.default);

FunnelChart.propTypes = (0, _extends3.default)({
  areaHeight: _propTypes2.default.number,
  areaWidth: _propTypes2.default.number,
  chartData: _propTypes2.default.array,
  children: _propTypes2.default.node,
  className: _propTypes2.default.string,
  classNamePrefix: _propTypes2.default.string,
  clipPath: _propTypes2.default.string,
  fill: _propTypes2.default.any,
  gapFill: _propTypes2.default.any,
  stroke: _propTypes2.default.any,
  gapStroke: _propTypes2.default.any,
  filter: _customPropTypes.stringOrArrayOfStrings,
  groupPadding: _propTypes2.default.any,
  mask: _customPropTypes.stringOrArrayOfStrings,
  minSize: _propTypes2.default.number,
  paddingBottom: _propTypes2.default.number,
  paddingLeft: _propTypes2.default.number,
  paddingRight: _propTypes2.default.number,
  paddingTop: _propTypes2.default.number,
  valueKeys: _propTypes2.default.array,
  xScale: _propTypes2.default.func,
  yScale: _propTypes2.default.func,
  onTooltipShow: _propTypes2.default.func,
  onTooltipHide: _propTypes2.default.func
}, _TransitionBase3.default.propTypes);
FunnelChart.defaultProps = (0, _extends3.default)({
  fill: true,
  groupPadding: 0.1,
  minSize: 3
}, _TransitionBase3.default.defaultProps);
var _default = FunnelChart;
exports.default = _default;
;

var _temp2 = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(FunnelChart, 'FunnelChart', 'src/charts/FunnelChart.js');

  __REACT_HOT_LOADER__.register(_default, 'default', 'src/charts/FunnelChart.js');
}();

;