'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _d3Shape = require('d3-shape');

var _d3Selection = require('d3-selection');

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _customPropTypes = require('../propTypes/customPropTypes');

var _asURLFragment = require('../helpers/asURLFragment');

var _asURLFragment2 = _interopRequireDefault(_asURLFragment);

var _TransitionBase2 = require('../helpers/TransitionBase');

var _TransitionBase3 = _interopRequireDefault(_TransitionBase2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var LineChart = function (_TransitionBase) {
  (0, _inherits3.default)(LineChart, _TransitionBase);

  function LineChart() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, LineChart);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = LineChart.__proto__ || (0, _getPrototypeOf2.default)(LineChart)).call.apply(_ref, [this].concat(args))), _this), _this.getStrokeColor = function (d, i) {
      if (_this.props.colorPalette) {
        if (_lodash2.default.isFunction(_this.props.colorPalette)) {
          return _this.props.colorPalette(i);
        } else {
          return _this.props.colorPalette[i];
        }
      }
      return _this.props.stroke;
    }, _this.getUniqueDataKey = function (dataSet, i) {
      return '' + _this.props.valueKeys[i];
    }, _this.getPathFilter = function (d, i) {
      var filter = _this.props.filter;
      if (_lodash2.default.isArray(filter)) {
        filter = filter[i];
      }
      if (filter) {
        return (0, _asURLFragment2.default)(filter);
      }
      return null;
    }, _this.getPathMask = function (d, i) {
      var mask = _this.props.mask;
      if (_lodash2.default.isArray(mask)) {
        mask = mask[i];
      }
      if (mask) {
        return (0, _asURLFragment2.default)(mask);
      }
      return null;
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(LineChart, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.curveType = this.props.curveType === 'curve' ? _d3Shape.curveMonotoneX : _d3Shape.curveLinear;
      this.renderChart();
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      this.curveType = this.props.curveType === 'curve' ? _d3Shape.curveMonotoneX : _d3Shape.curveLinear;
      this.renderChart();
    }
  }, {
    key: 'getYScale',
    value: function getYScale() {
      if (this.props.customYScaleDomain) {
        if (this.props.DEBUG) {
          /* eslint-disable no-console */
          console.debug('LineChart custom y scale domain passed, using a different domain than parent Chart');
        }
        return this.props.yScale.copy().domain(this.props.customYScaleDomain);
      } else {
        return this.props.yScale;
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var className = ['line-chart'];
      if (this.props.classNamePrefix) {
        className.push(this.props.classNamePrefix + '__line-chart');
      }
      if (this.props.className) {
        className.push(this.props.className);
      }
      return _react2.default.createElement('g', {
        className: className.join(' '),
        transform: 'translate(' + this.props.paddingLeft + ',' + this.props.paddingTop + ')',
        clipPath: this.props.clipPath,
        ref: function ref(n) {
          return _this2.lines = (0, _d3Selection.select)(n);
        }
      });
    }
  }, {
    key: 'renderChart',
    value: function renderChart() {
      var _this3 = this;

      if (this.props.DEBUG) {
        /* eslint-disable no-console */
        console.debug('LineChart render chartData', this.props.chartData);
      }
      var yScale = this.getYScale();
      var enterLineGenerator = (0, _d3Shape.line)().x(function (d) {
        return _this3.props.xScale(d.xValue);
      }).y(function () {
        return yScale(yScale.domain()[0]);
      }).curve(this.curveType);

      var lineGenerator = (0, _d3Shape.line)().x(function (d) {
        return _this3.props.xScale(d.xValue);
      }).y(function (d) {
        return yScale(d.yValue || 0);
      }).curve(this.curveType);

      var paths = this.lines.selectAll('.line-chart__line').data(this.props.chartData, this.getUniqueDataKey);

      paths.exit().call(this.applyTransition, function (selection) {
        return selection.attr('d', enterLineGenerator).remove();
      });

      paths.enter().append('path').attr('class', 'line-chart__line').attr('d', enterLineGenerator).merge(paths).style('stroke', this.getStrokeColor).style('stroke-width', this.props.strokeWidth).style('filter', this.getPathFilter).attr('mask', this.getPathMask).call(this.applyTransition, function (selection) {
        return selection.attr('d', lineGenerator);
      });
    }
  }]);
  return LineChart;
}(_TransitionBase3.default);

LineChart.propTypes = (0, _extends3.default)({
  chartData: _propTypes2.default.array,
  className: _propTypes2.default.string,
  classNamePrefix: _propTypes2.default.string,
  colorPalette: _propTypes2.default.any,
  curveType: _propTypes2.default.string,
  filter: _customPropTypes.stringOrArrayOfStrings,
  mask: _customPropTypes.stringOrArrayOfStrings,
  paddingBottom: _propTypes2.default.number,
  paddingLeft: _propTypes2.default.number,
  paddingRight: _propTypes2.default.number,
  paddingTop: _propTypes2.default.number,
  stroke: _customPropTypes.stringOrFunc,
  strokeWidth: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number, _propTypes2.default.func]),
  valueKeys: _propTypes2.default.array,
  xScale: _propTypes2.default.func,
  yScale: _propTypes2.default.func,
  customYScaleDomain: _propTypes2.default.array,
  clipPath: _propTypes2.default.string,
  DEBUG: _propTypes2.default.bool
}, _TransitionBase3.default.propTypes);
LineChart.defaultProps = (0, _extends3.default)({
  curveType: 'linear'
}, _TransitionBase3.default.defaultProps);
var _default = LineChart;
exports.default = _default;
;

var _temp2 = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(LineChart, 'LineChart', 'src/charts/LineChart.js');

  __REACT_HOT_LOADER__.register(_default, 'default', 'src/charts/LineChart.js');
}();

;