'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _d3Selection = require('d3-selection');

var _d3Shape = require('d3-shape');

var _d3Interpolate = require('d3-interpolate');

var _TooltipRenderer = require('../helpers/TooltipRenderer');

var _TooltipRenderer2 = _interopRequireDefault(_TooltipRenderer);

var _TransitionBase2 = require('../helpers/TransitionBase');

var _TransitionBase3 = _interopRequireDefault(_TransitionBase2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Orange = function (_TransitionBase) {
  (0, _inherits3.default)(Orange, _TransitionBase);

  function Orange() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, Orange);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = Orange.__proto__ || (0, _getPrototypeOf2.default)(Orange)).call.apply(_ref, [this].concat(args))), _this), _initialiseProps.call(_this), _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(Orange, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.tooltipRenderer = new _TooltipRenderer2.default(this);
      this.node.call(this.tooltipRenderer.bind);
      if (this.hasTooltip()) {
        this.tooltipRenderer.update(_react2.default.Children.only(this.props.children));
      }
      this.renderVisualization();
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      this.renderVisualization();
      if (this.hasTooltip()) {
        this.tooltipRenderer.update(_react2.default.Children.only(this.props.children));

        if (this.props.displayItem) {
          this.showTooltipForItem(this.props.displayItem);
        } else {
          this.hideTooltips();
        }
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.tooltipRenderer.onHide();
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      this.createGenerators();
      var className = ['pie-chart'];
      if (this.props.classNamePrefix) {
        className.push(this.props.classNamePrefix + '__pie-chart');
      }
      if (this.props.className) {
        className.push(this.props.className);
      }
      return _react2.default.createElement(
        'g',
        {
          className: className.join(' '),
          ref: function ref(n) {
            return _this2.node = (0, _d3Selection.select)(n);
          },
          transform: 'translate(' + (this.props.paddingLeft + this.props.areaWidth / 2) + ',' + (this.props.paddingTop + this.props.areaHeight / 2) + ')',
          clipPath: this.props.clipPath
        },
        _react2.default.createElement('g', {
          className: 'pie-chart__slices',
          ref: function ref(n) {
            return _this2.slices = n;
          }
        }),
        _react2.default.createElement('g', {
          className: 'pie-chart__labels',
          ref: function ref(n) {
            return _this2.labels = n;
          }
        }),
        _react2.default.createElement('g', {
          className: 'pie-chart__lines',
          ref: function ref(n) {
            return _this2.lines = n;
          }
        })
      );
    }
  }, {
    key: 'createGenerators',
    value: function createGenerators() {
      var radius = this.getRadius();
      this.pieArcGenerator = (0, _d3Shape.pie)().value(function (d) {
        return d.yValue || 0;
      });
      this.arcGenerator = (0, _d3Shape.arc)().outerRadius(radius * 0.8).innerRadius(radius * 0.3).padAngle(this.props.padAngle);
      this.edgeArcGenerator = (0, _d3Shape.arc)().outerRadius(radius * 0.8).innerRadius(radius * 0.8).padAngle(this.props.padAngle);
    }
  }, {
    key: 'renderVisualization',
    value: function renderVisualization() {
      var data = this.props.chartData[0];

      if (this.props.fillSlice) {
        this.renderPie(data, this.pieArcGenerator, this.arcGenerator);
      }
      if (this.props.labelFormat) {
        this.renderLabels(data, this.pieArcGenerator, this.edgeArcGenerator);
        this.renderLines(data, this.pieArcGenerator, this.edgeArcGenerator);
      }
      this.renderTooltips();
      this.enableClickEvents();
    }
  }, {
    key: 'renderPie',
    value: function renderPie(data, pieArcGenerator, arcGenerator) {
      var slicesGroup = (0, _d3Selection.select)(this.slices);
      var slices = slicesGroup.selectAll('.pie-chart__slice').data(pieArcGenerator(data), this.getUniqueDataKey);

      slices.exit().call(this.applyTransition, function (selection) {
        return selection.attrTween('d', function arcOut() {
          var interpolate = (0, _d3Interpolate.interpolate)(this.current, {
            startAngle: Math.PI * 2,
            endAngle: Math.PI * 2,
            value: 0
          });
          this.current = interpolate(0);
          return function interpolateTween(t) {
            return arcGenerator(interpolate(t));
          };
        }).remove();
      });

      slices.enter().append('path').attr('class', 'pie-chart__slice').attr('d', function initial(d) {
        var interpolate = (0, _d3Interpolate.interpolate)({
          startAngle: Math.PI * 2,
          endAngle: Math.PI * 2,
          value: 0
        }, d);
        this.current = interpolate(0);
        return arcGenerator(this.current);
      }).merge(slices).attr('id', this.getSliceId).attr('mask', this.getPathMask).style('fill', this.getFillColor).call(this.applyTransition, function (selection) {
        return selection.attrTween('d', function dTween(d) {
          this.current = this.current || d;
          var interpolate = (0, _d3Interpolate.interpolate)(this.current, d);
          this.current = interpolate(0);
          return function dGenerator(t) {
            return arcGenerator(interpolate(t));
          };
        });
      });
    }
  }, {
    key: 'renderLabels',
    value: function renderLabels(data, pieArcGenerator, arcGenerator) {
      var labelsGroup = (0, _d3Selection.select)(this.labels);
      var pieData = pieArcGenerator(data);
      var newPieData = this.filterOutSmallAngles(pieData);

      var labels = labelsGroup.selectAll('.pie-chart__label').data(newPieData, this.getUniqueDataKey);
      labels.exit().remove();

      var midAngle = this.midAngle;
      var radius = this.getRadius();

      labels.enter().append('text').attr('class', 'pie-chart__label').attr('dy', '0.33em').merge(labels).text(this.getLabelText).call(this.applyTransition, function (selection) {
        return selection.attrTween('transform', function transform(d) {
          this.current = this.current || d;
          var interpolate = (0, _d3Interpolate.interpolate)(this.current, d);
          this.current = interpolate(0);
          return function transfomer(t) {
            var d2 = interpolate(t);
            var pos = arcGenerator.centroid(d2);
            var rightOrLeftHalf = midAngle(d2) < Math.PI ? 1 : -1;
            pos[0] = radius * rightOrLeftHalf;
            return 'translate(' + pos + ')';
          };
        }).styleTween('text-anchor', function textAnchor(d) {
          this.current = this.current || d;
          var interpolate = (0, _d3Interpolate.interpolate)(this.current, d);
          this.current = interpolate(0);
          return function anchorer(t) {
            var d2 = interpolate(t);
            return midAngle(d2) < Math.PI ? 'start' : 'end';
          };
        });
      });
    }
  }, {
    key: 'renderLines',
    value: function renderLines(data, pieArcGenerator, arcGenerator) {
      var linesGroup = (0, _d3Selection.select)(this.lines);
      var pieData = pieArcGenerator(data);
      var newPieData = this.filterOutSmallAngles(pieData);

      var lines = linesGroup.selectAll('.pie-chart__line').data(newPieData, this.getUniqueDataKey);

      lines.exit().remove();

      var midAngle = this.midAngle;
      var radius = this.getRadius();

      lines.enter().append('polyline').attr('class', 'pie-chart__line').attr('points', function initialPoint(d) {
        var pos = arcGenerator.centroid(d);
        this.current = this.current || d;
        pos[0] = radius * 0.95 * (midAngle(d) < Math.PI ? 1 : -1);
        return [arcGenerator.centroid(d), pos];
      }).merge(lines).style('stroke', this.getFillColor).style('filter', this.getLineFilter).call(this.applyTransition, function (selection) {
        return selection.attrTween('points', function points(d) {
          this.current = this.current || d;
          var interpolate = (0, _d3Interpolate.interpolate)(this.current, d);
          this.current = interpolate(0);
          return function pointer(t) {
            var d2 = interpolate(t);
            var pos = arcGenerator.centroid(d2);
            pos[0] = radius * 0.95 * (midAngle(d2) < Math.PI ? 1 : -1);
            return [arcGenerator.centroid(d2), pos];
          };
        });
      });
    }
  }, {
    key: 'renderTooltips',
    value: function renderTooltips() {
      var slices = this.node.selectAll('.pie-chart__slice');
      if (this.hasTooltip()) {
        slices.on('mouseover.Orange', this.tooltipRenderer.onShow);
        slices.on('mouseout.Orange', this.tooltipRenderer.onHide);
        slices.on('mouseover.OrangeTooltip', this.onTooltipShow);
        slices.on('mouseout.OrangeTooltip', this.onTooltipHide);
        this.node.on('mousemove.Orange', this.tooltipRenderer.onMove);
      } else {
        slices.on('mouseover.Orange', null);
        slices.on('mouseout.Orange', null);
        slices.on('mouseover.OrangeTooltip', null);
        slices.on('mouseout.OrangeTooltip', null);
        this.node.on('mousemove.Orange', null);
      }
    }
  }, {
    key: 'enableClickEvents',
    value: function enableClickEvents() {
      var slices = this.node.selectAll('.pie-chart__slice');
      if (this.props.onElementClick) {
        slices.on('click', this.onSliceClick);
      }
    }
  }, {
    key: 'filterOutSmallAngles',
    value: function filterOutSmallAngles(pieData) {
      var _this3 = this;

      return pieData.filter(function (d) {
        return !_this3.isSmallAngle(d);
      });
    }
  }, {
    key: 'filterOutLargeAngles',
    value: function filterOutLargeAngles(pieData) {
      var _this4 = this;

      return pieData.filter(function (d) {
        return _this4.isSmallAngle(d);
      });
    }
  }, {
    key: 'midAngle',
    value: function midAngle(d) {
      return (d.startAngle + d.endAngle) / 2;
    }
  }, {
    key: 'hasTooltip',
    value: function hasTooltip() {
      return _react2.default.Children.count(this.props.children) === 1;
    }
  }, {
    key: 'showTooltipForItem',
    value: function showTooltipForItem() {
      if (this.props.displayItemFilter) {
        var slices = this.node.selectAll('.pie-chart__slice');
        slices.classed('hovered', false);
        var feature = slices.filter(this.props.displayItemFilter);
        feature.classed('hovered', true);
        feature.each(this.tooltipRenderer.onShow);
      }
    }
  }, {
    key: 'hideTooltips',
    value: function hideTooltips() {
      this.node.selectAll('.pie-chart__slice').classed('hovered', false).each(this.tooltipRenderer.onHide);
    }
  }]);
  return Orange;
}(_TransitionBase3.default);

Orange.propTypes = (0, _extends3.default)({
  areaHeight: _propTypes2.default.number,
  areaWidth: _propTypes2.default.number,
  chartData: _propTypes2.default.array,
  children: _propTypes2.default.node,
  className: _propTypes2.default.string,
  classNamePrefix: _propTypes2.default.string,
  clipPath: _propTypes2.default.string,
  colorPalette: _propTypes2.default.any,
  fillSlice: _propTypes2.default.bool,
  filter: _propTypes2.default.string,
  idKey: _propTypes2.default.string,
  labelFormat: _propTypes2.default.func,
  lineFilter: _propTypes2.default.string,
  mask: _propTypes2.default.any,
  padAngle: _propTypes2.default.number,
  paddingBottom: _propTypes2.default.number,
  paddingLeft: _propTypes2.default.number,
  paddingRight: _propTypes2.default.number,
  paddingTop: _propTypes2.default.number,
  pathFilter: _propTypes2.default.string,
  smallAngle: _propTypes2.default.number,
  valueKeys: _propTypes2.default.array,
  xScale: _propTypes2.default.func,
  yScale: _propTypes2.default.func,
  onElementClick: _propTypes2.default.func,
  onTooltipShow: _propTypes2.default.func,
  onTooltipHide: _propTypes2.default.func,
  displayItem: _propTypes2.default.object,
  displayItemFilter: _propTypes2.default.func
}, _TransitionBase3.default.propTypes);
Orange.defaultProps = (0, _extends3.default)({
  padAngle: 0.0,
  fillSlice: true,
  smallAngle: 10
}, _TransitionBase3.default.defaultProps);

var _initialiseProps = function _initialiseProps() {
  var _this5 = this;

  this.onTooltipShow = function (eventElement) {
    if (_this5.props.onTooltipShow) {
      _this5.props.onTooltipShow(eventElement.data.original);
    }
  };

  this.onTooltipHide = function (eventElement) {
    if (_this5.props.onTooltipHide) {
      _this5.props.onTooltipHide(eventElement.data.original);
    }
  };

  this.onSliceClick = function (eventElement) {
    if (_this5.props.onElementClick) {
      _this5.props.onElementClick(eventElement.data.original);
    }
  };

  this.getFillColor = function (d, i) {
    if (_this5.props.colorPalette) {
      return _lodash2.default.isFunction(_this5.props.colorPalette) ? _this5.props.colorPalette(i) : _this5.props.colorPalette[i];
    }
    return null;
  };

  this.getUniqueDataKey = function (dataSet) {
    return dataSet.data && dataSet.data.original && '' + dataSet.data.original[_this5.props.idKey];
  };

  this.getPathFilter = function (d, i) {
    var filter = _this5.props.pathFilter;
    if (_lodash2.default.isArray(filter)) {
      filter = filter[i];
    }
    if (filter) {
      return 'url(#' + filter + ')';
    }
    return null;
  };

  this.getLineFilter = function (d, i) {
    var filter = _this5.props.lineFilter;
    if (_lodash2.default.isArray(filter)) {
      filter = filter[i];
    }
    if (filter) {
      return 'url(#' + filter + ')';
    }
    return null;
  };

  this.getLabelText = function (d) {
    var _props;

    for (var _len2 = arguments.length, args = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
      args[_key2 - 1] = arguments[_key2];
    }

    return (_props = _this5.props).labelFormat.apply(_props, [d.data, d].concat(args));
  };

  this.getSliceId = function (d) {
    return 'arc-' + _this5.getUniqueDataKey(d);
  };

  this.getRadius = function () {
    return Math.min(_this5.props.areaHeight, _this5.props.areaWidth) / 2;
  };

  this.getPathMask = function (d, i) {
    var mask = _this5.props.mask;
    if (_lodash2.default.isArray(mask)) {
      mask = mask[i];
    }
    if (mask) {
      return 'url(#' + mask + ')';
    }
    return null;
  };

  this.isSmallAngle = function (d) {
    var degrees = (d.endAngle - d.startAngle) * (180 / Math.PI);
    return degrees <= _this5.props.smallAngle;
  };
};

var _default = Orange;
exports.default = _default;
;

var _temp2 = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(Orange, 'Orange', 'src/charts/Orange.js');

  __REACT_HOT_LOADER__.register(_default, 'default', 'src/charts/Orange.js');
}();

;