'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _d3Selection = require('d3-selection');

var _d3Shape = require('d3-shape');

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _customPropTypes = require('../propTypes/customPropTypes');

var _asURLFragment = require('../helpers/asURLFragment');

var _asURLFragment2 = _interopRequireDefault(_asURLFragment);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var PieChart = function (_Component) {
  (0, _inherits3.default)(PieChart, _Component);

  function PieChart() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, PieChart);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = PieChart.__proto__ || (0, _getPrototypeOf2.default)(PieChart)).call.apply(_ref, [this].concat(args))), _this), _initialiseProps.call(_this), _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(PieChart, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.renderPies();
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      this.renderPies();
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var className = ['pie-chart'];
      if (this.props.classNamePrefix) {
        className.push(this.props.classNamePrefix + '__pie-chart');
      }
      if (this.props.className) {
        className.push(this.props.className);
      }
      return _react2.default.createElement('g', {
        className: className.join(' '),
        ref: function ref(n) {
          return _this2.node = n;
        },
        transform: 'translate(' + (this.props.paddingLeft + this.props.areaWidth / 2) + ',' + (this.props.paddingTop + this.props.areaHeight / 2) + ')',
        clipPath: this.props.clipPath
      });
    }
  }, {
    key: 'renderPies',
    value: function renderPies() {
      this.group = (0, _d3Selection.select)(this.node);
      var pies = this.group.selectAll('.pie-chart__pie').data(this.props.chartData, this.getUniqueDataKey).enter().append('g');
      pies.attr('class', 'pie-chart__pie');
      this.renderPie();
    }
  }, {
    key: 'renderPie',
    value: function renderPie() {
      var pieArcGenerator = (0, _d3Shape.pie)().value(function (d) {
        return d.yValue || 0;
      });
      var arcGenerator = (0, _d3Shape.arc)().outerRadius(Math.min(this.props.areaHeight, this.props.areaWidth) / 2).innerRadius(Math.min(this.props.areaHeight, this.props.areaWidth) / 4).padAngle(this.props.padAngle);
      this.renderArcs(pieArcGenerator, arcGenerator);
      if (this.props.labelFormat) {
        this.renderArcInnerLabels(pieArcGenerator, arcGenerator);
      }
      if (this.props.outerLabelFormat) {
        this.renderArcOuterLabels(pieArcGenerator, arcGenerator);
      }
    }
  }, {
    key: 'renderArcs',
    value: function renderArcs(pieArcGenerator, arcGenerator) {
      var pies = this.group.selectAll('.pie-chart__pie');
      var slices = pies.selectAll('.pie-chart__pie__slice').data(pieArcGenerator).enter().append('path').attr('class', 'pie-chart__pie__slice').style('filter', this.getPathFilter);

      slices = pies.selectAll('.pie-chart__pie__slice').attr('d', arcGenerator).attr('id', this.getSliceId);
      if (this.props.colorPalette) {
        slices.style('fill', this.getFillColor);
      } else {
        slices.style('fill', null);
      }
    }
  }, {
    key: 'renderArcInnerLabels',
    value: function renderArcInnerLabels(pieArc, arc) {
      var pies = this.group.selectAll('.pie-chart__pie');
      pies.selectAll('.pie-chart__pie__slice__inner-labels').data(pieArc).enter().append('text').attr('class', 'pie-chart__pie__slice__inner-labels');

      var texts = pies.selectAll('.pie-chart__pie__slice__inner-labels').attr('transform', function (d) {
        return 'translate(' + arc.centroid(d) + ')';
      }).text(this.getInnerLabelText);
      if (this.props.labelDx) {
        texts.attr('dx', this.props.labelDx);
      } else {
        texts.attr('dx', null);
      }
      if (this.props.labelDy) {
        texts.attr('dy', this.props.labelDy);
      } else {
        texts.attr('dy', null);
      }
    }
  }, {
    key: 'renderArcOuterLabels',
    value: function renderArcOuterLabels(pieArc) {
      var _this3 = this;

      var pies = this.group.selectAll('.pie-chart__pie');
      pies.selectAll('.pie-chart__pie__slice__outer-label').data(pieArc).enter().append('text').attr('class', 'pie-chart__pie__slice__outer-label').append('textPath');

      var texts = pies.selectAll('.pie-chart__pie__slice__outer-label');
      if (this.props.outerLabelDx) {
        texts.attr('dx', this.props.outerLabelDx);
      }
      if (this.props.outerLabelDy) {
        texts.attr('dy', this.props.outerLabelDy);
      }
      pies.selectAll('.pie-chart__pie__slice__outer-label textPath').text(this.getOuterLabelText).attr('xlink:href', function () {
        return '#' + _this3.getSliceId.apply(_this3, arguments);
      });
    }
  }]);
  return PieChart;
}(_react.Component);

PieChart.propTypes = {
  chartData: _propTypes2.default.array,
  className: _propTypes2.default.string,
  classNamePrefix: _propTypes2.default.string,
  colorPalette: _propTypes2.default.any,
  filter: _customPropTypes.stringOrArrayOfStrings,
  paddingBottom: _propTypes2.default.number,
  paddingLeft: _propTypes2.default.number,
  paddingRight: _propTypes2.default.number,
  paddingTop: _propTypes2.default.number,
  valueKeys: _propTypes2.default.array,
  xScale: _propTypes2.default.func,
  yScale: _propTypes2.default.func,
  clipPath: _propTypes2.default.string,
  areaHeight: _propTypes2.default.number,
  areaWidth: _propTypes2.default.number,
  labelFormat: _propTypes2.default.func,
  labelDy: _customPropTypes.stringOrFunc,
  labelDx: _customPropTypes.stringOrFunc,
  outerLabelFormat: _propTypes2.default.func,
  outerLabelDy: _customPropTypes.stringOrFunc,
  outerLabelDx: _customPropTypes.stringOrFunc,
  padAngle: _propTypes2.default.number
};
PieChart.defaultProps = {
  padAngle: 0.01
};

var _initialiseProps = function _initialiseProps() {
  var _this4 = this;

  this.getFillColor = function (d, i) {
    return _lodash2.default.isFunction(_this4.props.colorPalette) ? _this4.props.colorPalette(i) : _this4.props.colorPalette[i];
  };

  this.getUniqueDataKey = function (dataSet, i) {
    return _this4.props.valueKeys[i];
  };

  this.getPathFilter = function (d, i) {
    var filter = _this4.props.filter;
    if (_lodash2.default.isArray(filter)) {
      filter = filter[i];
    }
    if (filter) {
      return (0, _asURLFragment2.default)(filter);
    }
    return undefined;
  };

  this.getInnerLabelText = function (d) {
    var _props;

    for (var _len2 = arguments.length, args = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
      args[_key2 - 1] = arguments[_key2];
    }

    return (_props = _this4.props).labelFormat.apply(_props, [d.data.yValue, d].concat(args));
  };

  this.getOuterLabelText = function (d) {
    var _props2;

    for (var _len3 = arguments.length, args = Array(_len3 > 1 ? _len3 - 1 : 0), _key3 = 1; _key3 < _len3; _key3++) {
      args[_key3 - 1] = arguments[_key3];
    }

    return (_props2 = _this4.props).outerLabelFormat.apply(_props2, [d.data.yValue, d].concat(args));
  };

  this.getSliceId = function (d, i) {
    return 'arc-' + d.data.yKey + '-' + i;
  };
};

var _default = PieChart;
exports.default = _default;
;

var _temp2 = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(PieChart, 'PieChart', 'src/charts/PieChart.js');

  __REACT_HOT_LOADER__.register(_default, 'default', 'src/charts/PieChart.js');
}();

;