'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _d3Selection = require('d3-selection');

require('d3-transition');

var _d3Hierarchy = require('d3-hierarchy');

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _numeral = require('numeral');

var _numeral2 = _interopRequireDefault(_numeral);

var _createHierarchyData = require('../helpers/createHierarchyData');

var _createHierarchyData2 = _interopRequireDefault(_createHierarchyData);

var _asURLFragment = require('../helpers/asURLFragment');

var _asURLFragment2 = _interopRequireDefault(_asURLFragment);

var _TooltipRenderer = require('../helpers/TooltipRenderer');

var _TooltipRenderer2 = _interopRequireDefault(_TooltipRenderer);

var _TransitionBase2 = require('../helpers/TransitionBase');

var _TransitionBase3 = _interopRequireDefault(_TransitionBase2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var BOX_W_LABEL_MIN_AREA = 35 * 35;
var TEXT_DEFAULT_FONT_SIZE = 0.9;
var TEXT_SIZE_BOX_RATIO = TEXT_DEFAULT_FONT_SIZE / 120;
var TEXT_LABEL_Y_OFFSET = 5;

var TreeMapChart = function (_TransitionBase) {
  (0, _inherits3.default)(TreeMapChart, _TransitionBase);

  function TreeMapChart() {
    var _ref;

    var _temp, _this2, _ret;

    (0, _classCallCheck3.default)(this, TreeMapChart);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this2 = (0, _possibleConstructorReturn3.default)(this, (_ref = TreeMapChart.__proto__ || (0, _getPrototypeOf2.default)(TreeMapChart)).call.apply(_ref, [this].concat(args))), _this2), _initialiseProps.call(_this2), _temp), (0, _possibleConstructorReturn3.default)(_this2, _ret);
  }

  (0, _createClass3.default)(TreeMapChart, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.tooltipRenderer = new _TooltipRenderer2.default(this);
      this.node.call(this.tooltipRenderer.bind);
      if (this.hasTooltip()) {
        this.tooltipRenderer.update(_react2.default.Children.only(this.props.children));
      }
      this.renderTreeMap();
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      this.renderTreeMap();
      if (this.hasTooltip()) {
        this.tooltipRenderer.update(_react2.default.Children.only(this.props.children));

        if (this.props.displayItem) {
          this.showTooltipForItem(this.props.displayItem);
        } else {
          this.hideTooltips();
        }
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var className = ['tree-map-chart'];
      if (this.props.classNamePrefix) {
        className.push(this.props.classNamePrefix + '__tree-map-chart');
      }
      if (this.props.className) {
        className.push(this.props.className);
      }
      if (this.props.valueKeys.length !== 1) {
        /* eslint-disable no-console */
        console.warn('TreeMapChart only supports one valueKey');
      }
      return _react2.default.createElement('g', {
        className: className.join(' '),
        transform: 'translate(' + this.props.paddingLeft + ' ' + this.props.paddingTop + ')',
        ref: function ref(n) {
          return _this3.node = (0, _d3Selection.select)(n);
        }
      });
    }
  }, {
    key: 'renderTreeMap',
    value: function renderTreeMap() {
      var treemap = (0, _d3Hierarchy.treemap)().size([this.props.areaWidth, this.props.areaHeight]).padding(this.props.tilePadding);
      var rootData = {
        root: true,
        children: this.props.chartData[0]
      };
      /* eslint-disable no-underscore-dangle */
      var _this = this;

      if (this.props.parentIdAttribute && this.props.idAttribute) {
        rootData = (0, _createHierarchyData2.default)(this.props.chartData[0], 'original.' + this.props.parentIdAttribute, 'original.' + this.props.idAttribute);
      }
      var root = (0, _d3Hierarchy.hierarchy)(rootData).sum(function (d) {
        return d.yValue || 0;
      });
      var nodes = treemap(root);
      var cells = this.node.selectAll('.tree-map-chart__leaf').data(nodes.leaves());

      cells.exit().remove();

      cells.enter().append('rect').attr('class', 'tree-map-chart__leaf').attr('mask', this.getCellMask).attr('filter', this.getCellFilter).merge(cells).call(this.applyTransition, function (selection) {
        return selection.attr('x', function (d) {
          return d.x0;
        }).attr('y', function (d) {
          return d.y0;
        }).attr('width', function (d) {
          return d.x1 - d.x0;
        }).attr('height', function (d) {
          return d.y1 - d.y0;
        }).attr('fill', _this.getFillColor).attr('stroke', _this.getStrokeColor);
      });

      if (this.props.fillCell) {
        var textNodes = this.node.selectAll('.tree-map-chart__leaf_content').data(nodes.leaves());

        textNodes.exit().remove();

        textNodes.enter().append('text').attr('class', 'tree-map-chart__leaf_content').each(function addTspans() {
          var txt = (0, _d3Selection.select)(this);
          txt.append('tspan').text(_this.getLabelText).attr('class', 'line1');
          txt.append('tspan').text(function (d) {
            return (0, _numeral2.default)(d.data.yValue || 0).format('0,0');
          }).attr('class', 'line2');
        }).merge(textNodes).call(this.applyTransition, function (selection) {
          selection.each(function transformTspans(d) {
            var txt = (0, _d3Selection.select)(this);

            var scaleRatio = 1;
            var cellWidth = d.x1 - d.x0;
            var cellHeight = d.y1 - d.y0;
            var transforms = ['translate(' + (d.x0 + cellWidth / 2) + 'px, ' + (d.y0 + cellHeight / 2) + 'px)'];

            if (_this.props.fitLabels) {
              // horizontal vs vertical text
              if (cellWidth < cellHeight) {
                transforms.push('rotate(-90deg)');
              }

              // adjust scale ratio
              var textSizeRatio = Math.max(cellWidth, cellHeight) * TEXT_SIZE_BOX_RATIO;
              scaleRatio = Math.min(1, textSizeRatio / TEXT_DEFAULT_FONT_SIZE);
              transforms.push('scale(' + scaleRatio + ')');

              // hide labels if box is really tiny
              txt.attr('opacity', cellWidth * cellHeight < BOX_W_LABEL_MIN_AREA ? '0' : '1');
            } else {
              var bbox = this.getBBox();
              txt.attr('opacity', bbox.width >= cellWidth || bbox.height >= cellHeight ? '0' : '1');
            }

            txt.select('.line1').text(_this.getLabelText);
            txt.select('.line2').text((0, _numeral2.default)(d.data.yValue || 0).format('0,0'));
            txt.attr('style', 'transform: ' + transforms.join(' '));
            txt.select('.line2').attr('x', 0).attr('y', _this.props.labelHeight - TEXT_LABEL_Y_OFFSET + TEXT_LABEL_Y_OFFSET * scaleRatio);
          });
        });
      }

      this.enableHoverEvents();
      this.enableClickEvents();
    }
  }, {
    key: 'enableHoverEvents',
    value: function enableHoverEvents() {
      var cells = this.node.selectAll('.tree-map-chart__leaf');

      if (this.props.enableHoverEvents) {
        cells.on('mouseover.TreeMap', this.tooltipRenderer.onShow);
        cells.on('mouseout.TreeMap', this.tooltipRenderer.onHide);
        cells.on('mouseover.TreeMapChart', this.onHoverOver);
        cells.on('mouseout.TreeMapChart', this.onHoverOut);
        this.node.on('mousemove.TreeMapChart', this.tooltipRenderer.onMove);
      } else {
        cells.on('mouseover.TreeMap', null);
        cells.on('mouseout.TreeMap', null);
        cells.on('mouseover.TreeMapChart', null);
        cells.on('mouseout.TreeMapChart', null);
        this.node.on('mousemove.TreeMapChart', null);
      }
    }
  }, {
    key: 'enableClickEvents',
    value: function enableClickEvents() {
      if (this.props.onElementClick) {
        this.node.selectAll('.tree-map-chart__leaf').on('click', this.onLeafClick);
      }
    }
  }, {
    key: 'hasTooltip',
    value: function hasTooltip() {
      return _react2.default.Children.count(this.props.children) === 1;
    }
  }, {
    key: 'showTooltipForItem',
    value: function showTooltipForItem() {
      if (this.props.displayItemFilter) {
        var leaves = this.node.selectAll('.tree-map-chart__leaf');
        leaves.classed('hovered', false);
        var feature = leaves.filter(this.props.displayItemFilter);
        feature.classed('hovered', true);
        feature.each(this.tooltipRenderer.onShow);
      }
    }
  }, {
    key: 'hideTooltips',
    value: function hideTooltips() {
      this.node.selectAll('.tree-map-chart__leaf').classed('hovered', false).each(this.tooltipRenderer.onHide);
    }
  }]);
  return TreeMapChart;
}(_TransitionBase3.default);

TreeMapChart.propTypes = (0, _extends3.default)({
  areaHeight: _propTypes2.default.number,
  areaWidth: _propTypes2.default.number,
  children: _propTypes2.default.node,
  className: _propTypes2.default.string,
  classNamePrefix: _propTypes2.default.string,
  chartData: _propTypes2.default.array,
  colorPalette: _propTypes2.default.any,
  displayItem: _propTypes2.default.object,
  displayItemFilter: _propTypes2.default.func,
  enableHoverEvents: _propTypes2.default.bool,
  fillCell: _propTypes2.default.bool,
  filter: _propTypes2.default.any,
  labelFormat: _propTypes2.default.func,
  labelHeight: _propTypes2.default.number,
  fitLabels: _propTypes2.default.bool,
  mask: _propTypes2.default.any,
  onElementClick: _propTypes2.default.func,
  onHoverOver: _propTypes2.default.func,
  onHoverOut: _propTypes2.default.func,
  paddingLeft: _propTypes2.default.number,
  paddingTop: _propTypes2.default.number,
  tilePadding: _propTypes2.default.number,
  idAttribute: _propTypes2.default.string,
  parentIdAttribute: _propTypes2.default.string,
  contentFormat: _propTypes2.default.func,
  tagName: _propTypes2.default.oneOf(['div', 'section']),
  valueKeys: _propTypes2.default.array,
  position: _propTypes2.default.string
}, _TransitionBase3.default.propTypes);
TreeMapChart.defaultProps = (0, _extends3.default)({
  enableHoverEvents: false,
  fillCell: true,
  labelHeight: 20, // FF has difficulty calculating text height during the d3 enter phase, this can be overridden as needed.
  fitLabels: false,
  tilePadding: 1,
  position: 'relative'
}, _TransitionBase3.default.defaultProps);

var _initialiseProps = function _initialiseProps() {
  var _this4 = this;

  this.onHoverOver = function (eventElement) {
    if (_this4.props.onHoverOver) {
      _this4.props.onHoverOver(eventElement.data.original);
    }
  };

  this.onHoverOut = function (eventElement) {
    if (_this4.props.onHoverOut) {
      _this4.props.onHoverOut(eventElement.data.original);
    }
  };

  this.onLeafClick = function (eventElement) {
    if (_this4.props.onElementClick) {
      _this4.props.onElementClick(eventElement.data.original);
    }
  };

  this.getCellFilter = function (d, i) {
    var filter = _lodash2.default.isArray(_this4.props.filter) ? _this4.props.filter[i] : _this4.props.filter;
    if (filter) {
      return (0, _asURLFragment2.default)(filter);
    }
    return null;
  };

  this.getCellMask = function (d, i) {
    var mask = _lodash2.default.isArray(_this4.props.mask) ? _this4.props.mask[i] : _this4.props.mask;
    if (mask) {
      return (0, _asURLFragment2.default)(mask);
    }
    return null;
  };

  this.getUniqueId = function (d, i) {
    return _lodash2.default.get(d.original, _this4.props.idAttribute) || i;
  };

  this.getFillColor = function (d, i) {
    if (_this4.props.fillCell && _this4.props.colorPalette) {
      return _lodash2.default.isFunction(_this4.props.colorPalette) ? _this4.props.colorPalette(i) : _this4.props.colorPalette[i];
    }
    return 'none';
  };

  this.getStrokeColor = function (d, i) {
    if (_this4.props.colorPalette) {
      return _lodash2.default.isFunction(_this4.props.colorPalette) ? _this4.props.colorPalette(i) : _this4.props.colorPalette[i];
    }
    return 'none';
  };

  this.getLabelText = function (d) {
    var _props;

    for (var _len2 = arguments.length, args = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
      args[_key2 - 1] = arguments[_key2];
    }

    return _lodash2.default.isFunction(_this4.props.labelFormat) ? (_props = _this4.props).labelFormat.apply(_props, [d.data, d].concat(args)) : 'Unknown';
  };
};

var _default = TreeMapChart;
exports.default = _default;
;

var _temp2 = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(BOX_W_LABEL_MIN_AREA, 'BOX_W_LABEL_MIN_AREA', 'src/charts/TreeMapChart.js');

  __REACT_HOT_LOADER__.register(TEXT_DEFAULT_FONT_SIZE, 'TEXT_DEFAULT_FONT_SIZE', 'src/charts/TreeMapChart.js');

  __REACT_HOT_LOADER__.register(TEXT_SIZE_BOX_RATIO, 'TEXT_SIZE_BOX_RATIO', 'src/charts/TreeMapChart.js');

  __REACT_HOT_LOADER__.register(TEXT_LABEL_Y_OFFSET, 'TEXT_LABEL_Y_OFFSET', 'src/charts/TreeMapChart.js');

  __REACT_HOT_LOADER__.register(TreeMapChart, 'TreeMapChart', 'src/charts/TreeMapChart.js');

  __REACT_HOT_LOADER__.register(_default, 'default', 'src/charts/TreeMapChart.js');
}();

;