'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

require('d3-selection-multi');

var _d3Selection = require('d3-selection');

var _d3Shape = require('d3-shape');

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _customPropTypes = require('../propTypes/customPropTypes');

var _TooltipRenderer = require('../helpers/TooltipRenderer');

var _TooltipRenderer2 = _interopRequireDefault(_TooltipRenderer);

var _asURLFragment = require('../helpers/asURLFragment');

var _asURLFragment2 = _interopRequireDefault(_asURLFragment);

var _valueOf = require('../helpers/valueOf');

var _valueOf2 = _interopRequireDefault(_valueOf);

var _TransitionBase2 = require('../helpers/TransitionBase');

var _TransitionBase3 = _interopRequireDefault(_TransitionBase2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var HALF_PI = Math.PI / 2;

var WebChart = function (_TransitionBase) {
  (0, _inherits3.default)(WebChart, _TransitionBase);

  function WebChart() {
    var _ref;

    var _temp, _this2, _ret;

    (0, _classCallCheck3.default)(this, WebChart);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this2 = (0, _possibleConstructorReturn3.default)(this, (_ref = WebChart.__proto__ || (0, _getPrototypeOf2.default)(WebChart)).call.apply(_ref, [this].concat(args))), _this2), _initialiseProps.call(_this2), _temp), (0, _possibleConstructorReturn3.default)(_this2, _ret);
  }

  (0, _createClass3.default)(WebChart, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.tooltipRenderer = new _TooltipRenderer2.default(this);
      this.node.call(this.tooltipRenderer.bind);
      if (this.hasTooltip()) {
        this.tooltipRenderer.update(_react2.default.Children.only(this.props.children));
      }
      this.renderVisualization();
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      this.renderVisualization();
      if (this.hasTooltip()) {
        this.tooltipRenderer.update(_react2.default.Children.only(this.props.children));
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var className = ['web-chart'];
      if (this.props.classNamePrefix) {
        className.push(this.props.classNamePrefix + '__web-chart');
      }
      if (this.props.className) {
        className.push(this.props.className);
      }

      this.guid = this.getGuid();

      return _react2.default.createElement(
        'g',
        {
          id: 'web-chart-g_guid' + this.guid,
          className: className.join(' '),
          ref: function ref(n) {
            return _this3.node = (0, _d3Selection.select)(n);
          },
          transform: 'translate(' + (this.props.paddingLeft + this.props.areaWidth / 2) + ',' + (this.props.paddingTop + this.props.areaHeight / 2) + ')',
          clipPath: this.props.clipPath
        },
        _react2.default.createElement('defs', { className: 'web-chart__defs', ref: function ref(n) {
            return _this3.defs = (0, _d3Selection.select)(n);
          } }),
        _react2.default.createElement(
          'g',
          { className: 'web-chart__rings' },
          this.renderRings()
        ),
        _react2.default.createElement(
          'g',
          { className: 'web-chart__lines' },
          this.renderLines()
        ),
        _react2.default.createElement('g', { className: 'web-chart__webbings', ref: function ref(n) {
            return _this3.webbings = (0, _d3Selection.select)(n);
          } }),
        this.props.includePlots ? _react2.default.createElement('g', { className: 'web-chart__plots', ref: function ref(n) {
            return _this3.plots = (0, _d3Selection.select)(n);
          } }) : null,
        _react2.default.createElement(
          'g',
          { className: 'web-chart__labels' },
          this.renderLabels()
        )
      );
    }
  }, {
    key: 'renderRings',
    value: function renderRings() {
      var _this4 = this;

      if (this.props.ringCount) {
        var maxRadius = this.maxRadius();
        var ringCount = this.props.ringCount;
        if (!this.props.ringsToEdge) {
          ringCount += 1;
        }
        var minRadius = maxRadius / ringCount;
        return _lodash2.default.times(this.props.ringCount, function (i) {
          if (!_this4.props.ringsToEdge && i === 0) {
            return undefined;
          }
          return _react2.default.createElement('circle', {
            key: 'ring-' + i,
            className: 'web-chart__ring',
            r: maxRadius - minRadius * i,
            cx: 0,
            cy: 0
          });
        });
      }
      return undefined;
    }
  }, {
    key: 'renderLines',
    value: function renderLines() {
      if (this.props.showLines && this.hasData()) {
        var data = this.props.chartData[0];
        var maxRadius = this.maxRadius();
        var perRadians = this.radiansPer();
        var startDegree = this.startDegree();
        return data.map(function (datum, i) {
          var key = datum.xValue || i;
          return _react2.default.createElement('line', {
            key: 'line-' + key,
            className: 'web-chart__line',
            x1: '0',
            y1: '0',
            x2: Math.cos(startDegree - perRadians * i) * maxRadius,
            y2: Math.sin(startDegree - perRadians * i) * maxRadius
          });
        });
      }
      return undefined;
    }
  }, {
    key: 'renderVisualization',
    value: function renderVisualization() {
      this.renderFills();
      this.renderOutlines();

      if (this.props.includePlots) {
        this.renderPlots();
      }

      this.renderTooltips();
      this.enableClickEvents();
    }
  }, {
    key: 'renderFills',
    value: function renderFills() {
      this.renderAreas(true);
    }
  }, {
    key: 'renderOutlines',
    value: function renderOutlines() {
      this.renderAreas(false);
    }
  }, {
    key: 'renderAreas',
    value: function renderAreas(isFilled) {
      var data = this.props.chartData[0] || [];
      var perDegree = 360 / data.length;
      var perRadians = perDegree * (Math.PI / 180);
      var maxRadius = this.maxRadius() * 0.95;

      var scale = this.props.yScale.copy().clamp(true);
      scale.range([0, maxRadius]).domain([0, scale.domain()[1]]);

      var emptyRadialLineGenerator = (0, _d3Shape.radialLine)().radius(function () {
        return 0;
      }).angle(function (d, n) {
        return perRadians * n;
      }).curve(_d3Shape.curveLinearClosed);

      var radialLineGenerator = (0, _d3Shape.radialLine)().radius(function (datum) {
        return scale(datum.yValue || 0);
      }).angle(function (datum, n) {
        return perRadians * n;
      }).curve(_d3Shape.curveLinearClosed);

      var isGradient = _lodash2.default.isArray(this.props.fill);
      if (isGradient) {
        this.renderGradientFill(perRadians, scale, emptyRadialLineGenerator, radialLineGenerator);
      } else {
        this.renderFill(isFilled, emptyRadialLineGenerator, radialLineGenerator);
      }
    }
  }, {
    key: 'renderGradientFill',
    value: function renderGradientFill(perRadians, scale, emptyRadialLineGenerator, radialLineGenerator) {
      var _this5 = this;

      var startDegree = this.startDegree();

      // flatten data for the simple fact that d3 can't handle selections nested more than 2 deep
      var flattenedMatrix = this.props.chartData.reduce(function (all, d, pi) {
        d.forEach(function (child, i) {
          child.parentIndex = pi;
          child.originalIndex = i;
        });
        return all.concat(d);
      }, []);

      // create the gradient group elements <g>
      var gradients = this.defs.selectAll('linearGradient').data(flattenedMatrix);

      gradients.exit().remove();

      // when a new gradient needs to be added, append it and define its properties
      // gradients should start at a vertex and end at the opposite end of the circle
      gradients.enter().append('linearGradient').attrs({
        id: function id(d) {
          return 'web-chart-gradient_' + d.parentIndex + '_' + d.originalIndex + '_' + _this5.guid;
        },
        gradientUnits: 'userSpaceOnUse',
        x1: function x1(d) {
          return (Math.cos(startDegree + perRadians * d.originalIndex) * scale(d.yValue || 0.00001)).toFixed(8);
        },
        y1: function y1(d) {
          return (Math.sin(startDegree + perRadians * d.originalIndex) * scale(d.yValue || 0.00001)).toFixed(8);
        },
        x2: 0,
        y2: 0
      }).merge(gradients);

      flattenedMatrix.forEach(function (lg) {
        var stopData = [(0, _valueOf2.default)(_this5.props.fill, null, lg.originalIndex), (0, _valueOf2.default)(_this5.props.fill, null, lg.originalIndex)];

        var stops = _this5.defs.selectAll('#web-chart-gradient_' + lg.parentIndex + '_' + lg.originalIndex + '_' + _this5.guid).selectAll('stop').data(stopData);

        stops.exit().remove();

        stops.enter().append('stop').attrs({
          offset: function offset(d, i) {
            return i * 100 + '%';
          },
          'stop-color': function stopColor(d) {
            return d;
          },
          'stop-opacity': function stopOpacity(d, i) {
            return '' + (1 - i * 1);
          }
        }).merge(stops);
      });

      /* Build the data matrix (3d array) that represents the hierarchy of the actual svg elements
       * <g> (Each item in the this.props.chartData property gets its own group)
       *   <path> (There are n paths per rendered area where n is the number of data points.
       * This is so each point can have its own gradient fill toward the center)
       */
      var dataMatrix = this.props.chartData.map(function (d, pi) {
        var arr = new Array(d.length);
        /* eslint-disable no-plusplus */
        for (var i = 0; i < arr.length; i++) {
          arr[i] = d.slice(0);
          arr[i].forEach(function (child) {
            return child.parentIndex = pi;
          });
        }
        return arr;
      });

      var areas = this.webbings.selectAll('g').data(dataMatrix);

      areas.exit().call(this.applyTransition, function (selection) {
        return selection.remove();
      });

      areas.enter().append('g').attrs({
        class: function _class(d, i) {
          return 'area_' + i;
        }
      }).merge(areas);

      // create the actual paths - one for each data point
      var paths = areas.selectAll('path').data(function (d) {
        return d;
      });

      paths.exit().call(this.applyTransition, function (selection) {
        return selection.remove();
      });

      // the paths should point to the <linearGradient> elements defined in the <defs>
      paths.enter().append('path').attrs({
        d: function d(_d) {
          return emptyRadialLineGenerator(_d);
        },
        class: 'webbing-gradient',
        fill: function fill(d, i) {
          return 'url(#web-chart-gradient_' + d[i].parentIndex + '_' + i + '_' + _this5.guid + ')';
        },
        stroke: function stroke(d, i) {
          return 'url(#web-chart-gradient_' + d[i].parentIndex + '_' + i + '_' + _this5.guid + ')';
        }
      }).merge(paths).call(this.applyTransition, function (selection) {
        return selection.attrs({ d: function d(_d2) {
            return radialLineGenerator(_d2);
          } });
      });
    }
  }, {
    key: 'renderFill',
    value: function renderFill(isFilled, emptyRadialLineGenerator, radialLineGenerator) {
      /* eslint-disable no-underscore-dangle */
      var _this = this;
      var areas = this.webbings.selectAll(isFilled ? '.webbing-area' : '.webbing-outline').data(this.props.chartData, this.getUniqueDataKey);

      areas.exit().call(this.applyTransition, function (selection) {
        return selection.remove();
      });

      areas.enter().append('path').attrs({
        d: function d(_d3) {
          return emptyRadialLineGenerator(_d3);
        },
        class: isFilled ? 'webbing-area' : 'webbing-outline',
        fill: function fill() {
          for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
            args[_key2] = arguments[_key2];
          }

          return isFilled ? _valueOf2.default.apply(undefined, [_this.props.fill].concat(args)) : 'none';
        },
        stroke: function stroke() {
          for (var _len3 = arguments.length, args = Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
            args[_key3] = arguments[_key3];
          }

          return isFilled ? 'none' : _valueOf2.default.apply(undefined, [_this.props.stroke].concat(args));
        }
      }).merge(areas).call(this.applyTransition, function (selection) {
        return selection.attrs({ d: function d(_d4) {
            return radialLineGenerator(_d4);
          } });
      });
    }
  }, {
    key: 'renderPlots',
    value: function renderPlots() {
      var _this6 = this;

      var data = this.props.chartData[0] || [];
      var perDegree = Math.PI * 2 / data.length;
      var isGradient = _lodash2.default.isArray(this.props.fill);
      var maxRadius = this.maxRadius() * 0.95;

      var plotGroups = this.plots.selectAll('.webbing-plot-group').data(this.props.chartData, this.getUniqueDataKey);

      var scale = this.props.yScale.copy().clamp(true);
      scale.range([0, maxRadius]).domain([0, scale.domain()[1]]);

      plotGroups.exit().remove();

      var groups = plotGroups.enter().append('g').attrs({
        class: 'webbing-plot-group'
      }).merge(plotGroups);

      var plots = groups.selectAll('.circle').data(function (d) {
        return d;
      });

      plots.exit().remove();

      plots.enter().append('circle').attrs({
        cx: 0,
        cy: 0,
        r: this.props.plotRadius,
        class: 'circle',
        fill: function fill() {
          for (var _len4 = arguments.length, args = Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
            args[_key4] = arguments[_key4];
          }

          return isGradient ? _valueOf2.default.apply(undefined, [_this6.props.fill].concat(args)) : _valueOf2.default.apply(undefined, [_this6.props.stroke].concat(args));
        }
      }).merge(plots).call(this.applyTransition, function (selection) {
        return selection.attrs({
          cx: function cx(d, i) {
            return scale(d.yValue) * Math.cos(perDegree * i - Math.PI / 2);
          },
          cy: function cy(d, i) {
            return scale(d.yValue) * Math.sin(perDegree * i - Math.PI / 2);
          }
        });
      });
    }
  }, {
    key: 'renderLabels',
    value: function renderLabels() {
      var _this7 = this;

      if (this.props.labelFormat && this.hasData()) {
        var data = this.props.chartData[0];
        var maxRadius = this.maxRadius() + this.props.labelOffset;
        var perRadians = this.radiansPer();
        var startDegree = this.startDegree();
        return data.map(function (d, i) {
          var degree = _this7.normalizeAngle(startDegree + perRadians * i);
          var x = Math.cos(degree) * maxRadius;
          var y = Math.sin(degree) * maxRadius;
          var labelValue = _this7.props.labelFormat(d, i, { x: x, y: y, degree: degree });
          var key = d.xValue || i;
          if (_lodash2.default.isString(labelValue) || _lodash2.default.isNumber(labelValue)) {
            return _this7.renderTextLabel(labelValue, degree, x, y, key);
          }
          return _react2.default.createElement(
            'g',
            { transform: 'translate(' + x + ',' + y + ')', className: 'web-chart__label', key: key },
            labelValue
          );
        });
      }
      return undefined;
    }
  }, {
    key: 'renderTextLabel',
    value: function renderTextLabel(labelValue, degree, x, y, key) {
      var textAnchor = 'end';
      var alignmentBaseline = 'baseline';
      if (degree === -HALF_PI || degree === HALF_PI) {
        textAnchor = 'middle';
      } else if (degree > -HALF_PI && degree < HALF_PI) {
        textAnchor = 'start';
      }
      if (degree >= 0) {
        alignmentBaseline = 'hanging';
      }
      return _react2.default.createElement(
        'text',
        {
          key: key,
          className: 'web-chart__label web-chart__label--text is-' + key,
          x: x,
          y: y,
          textAnchor: textAnchor,
          alignmentBaseline: alignmentBaseline,
          dominantBaseline: alignmentBaseline
        },
        labelValue
      );
    }
  }, {
    key: 'renderTooltips',
    value: function renderTooltips() {
      if (this.hasTooltip()) {
        if (this.props.includePlots && this.hasTooltip()) {
          var plots = this.node.selectAll('.web-chart__plots circle');
          plots.on('mouseover.plot', this.tooltipRenderer.onShow).on('mouseout.plot', this.tooltipRenderer.onHide).on('mouseover.item', this.onMouseover).on('mouseout.item', this.onMouseout);
        } else {
          var areas = this.node.selectAll('.web-chart__webbings .webbing-area');
          areas.on('mouseover.area', this.tooltipRenderer.onShow).on('mouseout.area', this.tooltipRenderer.onHide).on('mouseover.item', this.onMouseover).on('mouseout.item', this.onMouseout);
        }
      }
    }
  }, {
    key: 'hasData',
    value: function hasData() {
      return this.props.chartData.length && this.props.chartData[0].length;
    }
  }, {
    key: 'hasTooltip',
    value: function hasTooltip() {
      return _react2.default.Children.count(this.props.children) === 1;
    }
  }, {
    key: 'maxRadius',
    value: function maxRadius() {
      return Math.min(this.props.areaWidth, this.props.areaHeight) / 2;
    }
  }, {
    key: 'startDegree',
    value: function startDegree() {
      return -(Math.PI / 2);
    }
  }, {
    key: 'radiansPer',
    value: function radiansPer() {
      var data = this.props.chartData[0] || [];
      var perDegree = 360 / data.length;
      return perDegree * (Math.PI / 180);
    }
  }, {
    key: 'normalizeAngle',
    value: function normalizeAngle(angle) {
      return Math.atan2(Math.sin(angle), Math.cos(angle));
    }
  }, {
    key: 'enableClickEvents',
    value: function enableClickEvents() {
      if (this.props.onElementClick) {
        this.node.selectAll('.web-chart__plots circle').on('click', this.onPlotClick);
      }
    }
  }]);
  return WebChart;
}(_TransitionBase3.default);

WebChart.propTypes = (0, _extends3.default)({
  areaHeight: _propTypes2.default.number,
  areaWidth: _propTypes2.default.number,
  chartData: _propTypes2.default.array,
  children: _propTypes2.default.node,
  className: _propTypes2.default.string,
  classNamePrefix: _propTypes2.default.string,
  clipPath: _propTypes2.default.string,
  fill: _propTypes2.default.any,
  filter: _customPropTypes.stringOrArrayOfStrings,
  includePlots: _propTypes2.default.bool,
  labelFormat: _propTypes2.default.func,
  labelOffset: _propTypes2.default.number,
  padAngle: _propTypes2.default.number,
  paddingBottom: _propTypes2.default.number,
  paddingLeft: _propTypes2.default.number,
  paddingRight: _propTypes2.default.number,
  paddingTop: _propTypes2.default.number,
  plotRadius: _propTypes2.default.number,
  ringCount: _propTypes2.default.number,
  ringsToEdge: _propTypes2.default.bool,
  showLines: _propTypes2.default.bool,
  stroke: _propTypes2.default.any,
  valueKeys: _propTypes2.default.array,
  xScale: _propTypes2.default.func,
  yScale: _propTypes2.default.func,
  onElementClick: _propTypes2.default.func,
  onMouseover: _propTypes2.default.func,
  onMouseout: _propTypes2.default.func
}, _TransitionBase3.default.propTypes);
WebChart.defaultProps = (0, _extends3.default)({
  labelOffset: 0,
  padAngle: 0.01,
  plotRadius: 3,
  ringCount: 5,
  ringsToEdge: false,
  showLines: true
}, _TransitionBase3.default.defaultProps);

var _initialiseProps = function _initialiseProps() {
  var _this8 = this;

  this.onMouseover = function (data) {
    if (_this8.props.onMouseover) {
      _this8.props.onMouseover(data.original);
    }
  };

  this.onMouseout = function (data) {
    if (_this8.props.onMouseout) {
      _this8.props.onMouseout(data.original);
    }
  };

  this.onPlotClick = function (eventElement) {
    if (_this8.props.onElementClick) {
      _this8.props.onElementClick(eventElement.original);
    }
  };

  this.getGuid = function () {
    if (_this8.guid) {
      return _this8.guid;
    }

    var guid = 0;
    var id = void 0;
    do {
      guid += 1;
      id = 'web-chart-g_guid' + guid;
    } while (window.document.getElementById(id));
    return guid;
  };

  this.getUniqueDataKey = function (dataSet, i) {
    return _this8.props.valueKeys[i];
  };

  this.getPathFilter = function () {
    for (var _len5 = arguments.length, args = Array(_len5), _key5 = 0; _key5 < _len5; _key5++) {
      args[_key5] = arguments[_key5];
    }

    var filter = _valueOf2.default.apply(undefined, [_this8.props.filter].concat(args));
    if (filter) {
      return (0, _asURLFragment2.default)(filter);
    }
    return undefined;
  };
};

var _default = WebChart;
exports.default = _default;
;

var _temp2 = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(HALF_PI, 'HALF_PI', 'src/charts/WebChart.js');

  __REACT_HOT_LOADER__.register(WebChart, 'WebChart', 'src/charts/WebChart.js');

  __REACT_HOT_LOADER__.register(_default, 'default', 'src/charts/WebChart.js');
}();

;