'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _d3Scale = require('d3-scale');

var _d3Selection = require('d3-selection');

var _d3Array = require('d3-array');

require('d3-transition');

require('d3-selection-multi');

var _d3Cloud = require('d3-cloud');

var _d3Cloud2 = _interopRequireDefault(_d3Cloud);

var _TransitionBase2 = require('../helpers/TransitionBase');

var _TransitionBase3 = _interopRequireDefault(_TransitionBase2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var DEFAULT_OPACITY = 0.50;
var fontScales = {
  scaleSqrt: _d3Scale.scaleSqrt,
  scaleLog: _d3Scale.scaleLog,
  scaleLinear: _d3Scale.scaleLinear
};
var watchProps = ['data', 'getRotation', 'fontScale', 'fontScaleRange', 'layout', 'areaWidth', 'areaHeight'];

var WordCloud = function (_TransitionBase) {
  (0, _inherits3.default)(WordCloud, _TransitionBase);

  function WordCloud(props) {
    var _ref;

    (0, _classCallCheck3.default)(this, WordCloud);

    for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      args[_key - 1] = arguments[_key];
    }

    var _this = (0, _possibleConstructorReturn3.default)(this, (_ref = WordCloud.__proto__ || (0, _getPrototypeOf2.default)(WordCloud)).call.apply(_ref, [this, props].concat(args)));

    _initialiseProps.call(_this);

    _this.initialHeight = 600;
    _this.initialWidth = 1000;
    return _this;
  }

  (0, _createClass3.default)(WordCloud, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.updateScale(this.props);
      this.updateCloudGen(this.props);
      this.renderVis();
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps) {
      if (_lodash2.default.isEqual(_lodash2.default.pick(this.props, watchProps), _lodash2.default.pick(nextProps, watchProps))) {
        return false;
      }
      return true;
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps) {
      if (prevProps.areaHeight !== this.props.areaHeight || prevProps.areaWidth !== this.props.areaWidth) {
        this.resizeSVG(this.props.areaWidth, this.props.areaHeight);
      }
      this.updateScale(this.props);
      this.updateCloudGen(this.props);
      this.renderVis();
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var w = this.props.areaWidth || this.initialWidth;
      var h = this.props.areaHeight || this.initialHeight;
      return _react2.default.createElement('g', {
        ref: function ref(n) {
          return _this2.node = n;
        },
        transform: 'translate(' + w / 2 + ' ' + h / 2 + ')'
      });
    }
  }]);
  return WordCloud;
}(_TransitionBase3.default);

WordCloud.propTypes = (0, _extends3.default)({
  areaHeight: _propTypes2.default.number,
  areaWidth: _propTypes2.default.number,
  data: _propTypes2.default.array,
  font: _propTypes2.default.string,
  fontScale: _propTypes2.default.string,
  fontScaleRange: _propTypes2.default.array,
  fontWeight: _propTypes2.default.string,
  getCount: _propTypes2.default.func,
  getRotation: _propTypes2.default.func,
  getWord: _propTypes2.default.func,
  layout: _propTypes2.default.string,
  onClick: _propTypes2.default.func,
  paddingLeft: _propTypes2.default.number,
  paddingTop: _propTypes2.default.number,
  colorPalette: _propTypes2.default.any
}, _TransitionBase3.default.propTypes);
WordCloud.defaultProps = (0, _extends3.default)({
  font: 'sans-serif',
  fontScale: 'scaleLog',
  fontScaleRange: [18, 100],
  fontWeight: '400',
  layout: 'archimedean'
}, _TransitionBase3.default.defaultProps);

var _initialiseProps = function _initialiseProps() {
  var _this3 = this;

  this.onClick = function (d) {
    if (_lodash2.default.isFunction(_this3.props.onClick)) {
      _this3.props.onClick(d);
    }
  };

  this.getFillColor = function (d, i) {
    if (_lodash2.default.isFunction(_this3.props.colorPalette)) {
      return _this3.props.colorPalette(i);
    } else if (_lodash2.default.isArray(_this3.props.colorPalette)) {
      return _this3.props.colorPalette[i % _this3.props.colorPalette.length];
    }
    return null;
  };

  this.getCount = function (d) {
    if (_lodash2.default.isFunction(_this3.props.getCount)) {
      return _this3.props.getCount(d);
    }

    return d.count;
  };

  this.getFontSize = function (d) {
    return _this3.fontScale(+d.count);
  };

  this.getRotation = function (d) {
    if (_lodash2.default.isFunction(_this3.props.getRotation)) {
      return _this3.props.getRotation(d);
    }

    return 0;
  };

  this.getWord = function (d) {
    if (_lodash2.default.isFunction(_this3.props.getWord)) {
      return _this3.props.getWord(d);
    }

    return d.word;
  };

  this.handleMouseOver = function (node, d) {
    (0, _d3Selection.select)(node).style('opacity', 1).style('font-size', d.size + 5);
  };

  this.handleMouseOut = function (node, d) {
    (0, _d3Selection.select)(node).style('opacity', DEFAULT_OPACITY).style('font-size', d.size - 5);
  };

  this.renderVis = function () {
    _this3.cloudGen.start();
  };

  this.renderCloud = function (words) {
    var self = _this3;
    var cloud = (0, _d3Selection.select)(_this3.node);
    var texts = cloud.selectAll('.text-elements').data(words);

    texts.exit().call(_this3.applyTransition, function (selection) {
      return selection.attrs({
        'font-size': 0
      });
    }).remove();

    texts.enter().append('text').attrs({
      'text-anchor': 'middle',
      class: 'text-elements'
    }).style('font-family', _this3.props.font).style('font-weight', _this3.props.fontWeight).style('transition', '0.3s').style('cursor', 'default').style('opacity', DEFAULT_OPACITY).on('click', _this3.onClick).on('mouseover', function mouseover(d, i) {
      return self.handleMouseOver(this, d, i);
    }).on('mouseout', function mouseout(d, i) {
      return self.handleMouseOut(this, d, i);
    }).merge(texts).text(_this3.getWord).attrs({
      fill: _this3.getFillColor
    }).call(_this3.applyTransition, function (selection) {
      return selection.attrs({
        transform: function transform(d) {
          return 'translate(' + d.x + ' ' + d.y + ') rotate(' + d.rotate + ')';
        },
        'font-size': function fontSize(d) {
          return d.size - 3;
        }
      });
    });
  };

  this.updateScale = function (props) {
    _this3.fontScale = fontScales[props.fontScale]().domain((0, _d3Array.extent)(props.data, _this3.getCount)).range(props.fontScaleRange);
  };

  this.updateCloudGen = function (props) {
    var w = _this3.props.areaWidth || _this3.initialWidth;
    var h = _this3.props.areaHeight || _this3.initialHeight;
    _this3.cloudGen = (0, _d3Cloud2.default)().size([w, h]).timeInterval(20).spiral(props.layout).words(props.data).font(props.font).fontSize(_this3.getFontSize).text(_this3.getWord).rotate(_this3.getRotation).padding(3).on('end', _this3.renderCloud);
  };

  this.resizeSVG = function (newWidth, newHeight) {
    var w = newWidth || _this3.initialWidth;
    var h = newHeight || _this3.initialHeight;
    (0, _d3Selection.select)(_this3.node).attrs({
      transform: 'translate(' + w / 2 + ' ' + h / 2 + ')'
    });
  };
};

var _default = WordCloud;
exports.default = _default;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(DEFAULT_OPACITY, 'DEFAULT_OPACITY', 'src/charts/WordCloud.js');

  __REACT_HOT_LOADER__.register(fontScales, 'fontScales', 'src/charts/WordCloud.js');

  __REACT_HOT_LOADER__.register(watchProps, 'watchProps', 'src/charts/WordCloud.js');

  __REACT_HOT_LOADER__.register(WordCloud, 'WordCloud', 'src/charts/WordCloud.js');

  __REACT_HOT_LOADER__.register(_default, 'default', 'src/charts/WordCloud.js');
}();

;