'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _react = require('react');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

require('d3-transition');

var _d3Ease = require('d3-ease');

var _customPropTypes = require('../propTypes/customPropTypes');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var d3Eases = {
  easePolyInOut: _d3Ease.easePolyInOut
};

var TransitionBase = function (_Component) {
  (0, _inherits3.default)(TransitionBase, _Component);

  function TransitionBase() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, TransitionBase);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = TransitionBase.__proto__ || (0, _getPrototypeOf2.default)(TransitionBase)).call.apply(_ref, [this].concat(args))), _this), _this.applyTransition = function (selection, afterTransitionFn) {
      if (_this.props.disableTransition) {
        return _this.onTransitionComplete(selection, afterTransitionFn);
      }

      var selectionAfterTransition = selection.transition(_this.getTransition(selection));
      return _this.onTransitionComplete(selectionAfterTransition, afterTransitionFn);
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(TransitionBase, [{
    key: 'onTransitionComplete',
    value: function onTransitionComplete(selection, fn) {
      return _lodash2.default.isFunction(fn) ? fn(selection) : selection;
    }
  }, {
    key: 'getTransition',
    value: function getTransition(selection) {
      if (this.props.transition) {
        return this.props.transition;
      }

      var ease = _lodash2.default.isFunction(this.props.transitionEase) ? this.props.transitionEase : d3Eases[this.props.transitionEase];
      return selection.transition().duration(this.props.transitionDuration).delay(this.props.transitionDelay).ease(ease);
    }
  }]);
  return TransitionBase;
}(_react.Component);

TransitionBase.propTypes = {
  transitionDelay: _propTypes2.default.number,
  transitionDuration: _propTypes2.default.number,
  transitionEase: _customPropTypes.stringOrFunc,
  transition: _propTypes2.default.func,
  disableTransition: _propTypes2.default.bool
};
TransitionBase.defaultProps = {
  transitionDelay: 0,
  transitionDuration: 0,
  transitionEase: _d3Ease.easePolyInOut
};
var _default = TransitionBase;
exports.default = _default;
;

var _temp2 = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(d3Eases, 'd3Eases', 'src/helpers/TransitionBase.js');

  __REACT_HOT_LOADER__.register(TransitionBase, 'TransitionBase', 'src/helpers/TransitionBase.js');

  __REACT_HOT_LOADER__.register(_default, 'default', 'src/helpers/TransitionBase.js');
}();

;