'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

exports.default = createHierarchyData;

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createHierarchyData(data, parentIdAttribute, idAttribute) {
  var topLevel = [];
  var possibleChildren = [];
  var seenIds = {};
  data.forEach(function (d) {
    var datum = (0, _extends3.default)({}, d, { children: [] });
    var id = _lodash2.default.get(datum, idAttribute);
    var parentId = _lodash2.default.get(datum, parentIdAttribute);
    if (id !== undefined) {
      var idKey = '' + id;
      seenIds[idKey] = datum;
    }
    if (parentId !== undefined && parentId !== null) {
      possibleChildren.push(datum);
    } else {
      topLevel.push(datum);
    }
  });
  possibleChildren.forEach(function (datum) {
    var parentId = _lodash2.default.get(datum, parentIdAttribute);
    var parentIdKey = '' + parentId;
    if (seenIds.hasOwnProperty(parentIdKey)) {
      var parent = seenIds[parentIdKey];
      parent.children.push(datum);
    } else {
      topLevel.push(datum);
    }
  });
  return {
    root: true,
    children: topLevel
  };
}
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(createHierarchyData, 'createHierarchyData', 'src/helpers/createHierarchyData.js');
}();

;