'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _nuviReactAnnotation = require('nuvi-react-annotation');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var annotationClasses = {
  AnnotationCalloutElbow: _nuviReactAnnotation.AnnotationCalloutElbow,
  AnnotationCalloutCircle: _nuviReactAnnotation.AnnotationCalloutCircle,
  AnnotationCalloutRect: _nuviReactAnnotation.AnnotationCalloutRect,
  AnnotationLabel: _nuviReactAnnotation.AnnotationLabel,
  DraggableAnnotation: _nuviReactAnnotation.DraggableAnnotation,
  elbow: _nuviReactAnnotation.AnnotationCalloutElbow,
  circle: _nuviReactAnnotation.AnnotationCalloutCircle,
  rect: _nuviReactAnnotation.AnnotationCalloutRect,
  label: _nuviReactAnnotation.AnnotationLabel
};
/* eslint-disable no-unused-vars */

var InteractiveAnnotationLayer = function (_React$Component) {
  (0, _inherits3.default)(InteractiveAnnotationLayer, _React$Component);

  function InteractiveAnnotationLayer() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, InteractiveAnnotationLayer);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = InteractiveAnnotationLayer.__proto__ || (0, _getPrototypeOf2.default)(InteractiveAnnotationLayer)).call.apply(_ref, [this].concat(args))), _this), _this.renderAnnotations = function () {
      var annotations = _this.props.annotations.map(function (annot, i) {
        if (!(annot.type in annotationClasses)) {
          return null;
        }
        var Annotation = annotationClasses[annot.type];
        var color = annot.color,
            connector = annot.connector,
            disable = annot.disable,
            dx = annot.dx,
            dy = annot.dy,
            editMode = annot.editMode,
            id = annot.id,
            note = annot.note,
            subject = annot.subject,
            x = annot.x,
            y = annot.y;

        var key = 'annotation_' + i;
        return _react2.default.createElement(Annotation, {
          color: color,
          connector: connector,
          disable: disable,
          dx: dx,
          dy: dy,
          editMode: editMode,
          events: {
            onClick: _this.props.onClick.bind(_this, id)
          },
          id: id,
          key: key,
          note: note,
          onDragEnd: _this.props.onDragEnd.bind(_this, id),
          scale: _this.props.scale,
          subject: subject,
          x: x,
          y: y
        });
      });

      return annotations;
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(InteractiveAnnotationLayer, [{
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'g',
        {
          className: 'annotation-layer'
        },
        this.renderAnnotations()
      );
    }
  }]);
  return InteractiveAnnotationLayer;
}(_react2.default.Component);

InteractiveAnnotationLayer.propTypes = {
  annotations: _propTypes2.default.array,
  onClick: _propTypes2.default.func,
  onDragEnd: _propTypes2.default.func,
  scale: _propTypes2.default.number
};
var _default = InteractiveAnnotationLayer;
exports.default = _default;
;

var _temp2 = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(annotationClasses, 'annotationClasses', 'src/layers/InteractiveAnnotationLayer.js');

  __REACT_HOT_LOADER__.register(InteractiveAnnotationLayer, 'InteractiveAnnotationLayer', 'src/layers/InteractiveAnnotationLayer.js');

  __REACT_HOT_LOADER__.register(_default, 'default', 'src/layers/InteractiveAnnotationLayer.js');
}();

;