'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _d3Selection = require('d3-selection');

var _d3Drag = require('d3-drag');

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var RangeSelector = function (_Component) {
  (0, _inherits3.default)(RangeSelector, _Component);

  function RangeSelector() {
    var _ref;

    (0, _classCallCheck3.default)(this, RangeSelector);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    var _this = (0, _possibleConstructorReturn3.default)(this, (_ref = RangeSelector.__proto__ || (0, _getPrototypeOf2.default)(RangeSelector)).call.apply(_ref, [this].concat(args)));

    _this.onDrag = _this.onDrag.bind(_this);
    _this.onLeftHandleDrag = _this.onLeftHandleDrag.bind(_this);
    _this.onRightHandleDrag = _this.onRightHandleDrag.bind(_this);
    return _this;
  }

  (0, _createClass3.default)(RangeSelector, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.setupListeners();
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.teardownListeners();
    }
  }, {
    key: 'onDrag',
    value: function onDrag() {
      var newXPosition = parseFloat(this.clip.attr('x')) + event.movementX; // eslint-disable-line no-undef
      newXPosition = this.rightAreaBoundary(newXPosition);
      newXPosition = this.leftAreaBoundary(newXPosition);

      var newEnd = newXPosition + parseFloat(this.clip.attr('width'));
      var newStartDomain = this.props.xScale.invert(newXPosition);
      var newEndDomain = this.props.xScale.invert(newEnd);

      this.props.onRangeChange(newStartDomain, newEndDomain);
    }
  }, {
    key: 'onLeftHandleDrag',
    value: function onLeftHandleDrag() {
      var newXPosition = parseFloat(this.leftHandle.attr('x')) + event.movementX; // eslint-disable-line no-undef

      newXPosition = this.rightAreaBoundary(newXPosition); // right areaWidth boundary
      newXPosition = this.leftAreaBoundary(newXPosition); // left areaWidth boundary
      newXPosition = this.determinMinRightPosition(newXPosition); // rightHandle boundary
      newXPosition = this.determineMaxRightPosition(newXPosition); // max Width boundary

      var newStartDomain = this.props.xScale.invert(newXPosition);
      this.props.onRangeChange(newStartDomain, this.props.end);
    }
  }, {
    key: 'onRightHandleDrag',
    value: function onRightHandleDrag() {
      var newXPosition = parseFloat(this.rightHandle.attr('x')) + event.movementX; // eslint-disable-line no-undef

      newXPosition = this.rightAreaBoundary(newXPosition); // right areaWidth boundary
      newXPosition = this.leftAreaBoundary(newXPosition); // left areaWidth boundary
      newXPosition = this.determineMinLeftPosition(newXPosition); // LeftHandle boundary
      newXPosition = this.determineMaxLeftPosition(newXPosition); // max Width boundary

      var newEndDomain = this.props.xScale.invert(newXPosition);
      this.props.onRangeChange(this.props.start, newEndDomain);
    }
  }, {
    key: 'setupListeners',
    value: function setupListeners() {
      this.clip.call((0, _d3Drag.drag)().on('drag.RangeSelectorDrag', this.onDrag));
      this.leftHandle.call((0, _d3Drag.drag)().on('drag.RangeSelectorLeftHandle', this.onLeftHandleDrag));
      this.rightHandle.call((0, _d3Drag.drag)().on('drag.RangeSelectorRightHandle', this.onRightHandleDrag));
    }
  }, {
    key: 'getClassNames',
    value: function getClassNames() {
      var className = ['range-selector'];
      if (this.props.classNamePrefix) {
        className.push(this.props.classNamePrefix + '__range-selector');
      }
      if (this.props.className) {
        className.push(this.props.className);
      }
      return className.join(' ');
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var y = this.props.paddingTop;
      var height = this.props.areaHeight;

      var start = this.props.xScale(this.props.start);
      var end = this.props.xScale(this.props.end);
      var width = Math.abs(start - end);

      return _react2.default.createElement(
        'g',
        {
          className: this.getClassNames(),
          ref: function ref(n) {
            return _this2.node = (0, _d3Selection.select)(n);
          }
        },
        _react2.default.createElement('rect', {
          className: 'range-selector__handle range-selector__handle--middle',
          height: height,
          width: width,
          x: start,
          y: y,
          ref: function ref(n) {
            return _this2.clip = (0, _d3Selection.select)(n);
          }
        }),
        _react2.default.createElement('rect', {
          className: 'range-selector__handle range-selector__handle--right',
          height: height,
          width: this.props.handleWidth,
          x: start,
          y: y,
          ref: function ref(n) {
            return _this2.leftHandle = (0, _d3Selection.select)(n);
          }
        }),
        _react2.default.createElement('rect', {
          className: 'range-selector__handle range-selector__handle--right',
          height: height,
          width: this.props.handleWidth,
          x: end,
          y: y,
          ref: function ref(n) {
            return _this2.rightHandle = (0, _d3Selection.select)(n);
          }
        })
      );
    }
  }, {
    key: 'minClipSizePixels',
    value: function minClipSizePixels() {
      // returns min width range in px
      var boundary = void 0;
      if (this.props.start instanceof Date) {
        boundary = (0, _moment2.default)(this.props.start).add(this.props.minClipSize, 'millisecond');
      } else {
        boundary = this.props.start + this.props.minClipSize;
      }

      return Math.abs(this.props.xScale(this.props.start) - this.props.xScale(boundary));
    }
  }, {
    key: 'maxClipSizePixels',
    value: function maxClipSizePixels() {
      // returns max width range in px
      var boundary = void 0;
      if (this.props.start instanceof Date) {
        boundary = (0, _moment2.default)(this.props.start).add(this.props.maxClipSize, 'millisecond');
      } else {
        boundary = this.props.start + this.props.maxClipSize;
      }
      return Math.abs(this.props.xScale(this.props.start) - this.props.xScale(boundary));
    }
  }, {
    key: 'determinMinRightPosition',
    value: function determinMinRightPosition(newX) {
      var rightBoundary = Math.abs(parseFloat(this.rightHandle.attr('x')) - this.minClipSizePixels());
      return Math.min(newX, rightBoundary);
    }
  }, {
    key: 'determineMaxRightPosition',
    value: function determineMaxRightPosition(newX) {
      var rightBoundary = Math.abs(parseFloat(this.rightHandle.attr('x')) - this.maxClipSizePixels());
      return Math.max(rightBoundary, newX);
    }
  }, {
    key: 'determineMinLeftPosition',
    value: function determineMinLeftPosition(newX) {
      var leftBoundary = Math.abs(parseFloat(this.leftHandle.attr('x')) + this.minClipSizePixels());
      return Math.max(newX, leftBoundary);
    }
  }, {
    key: 'determineMaxLeftPosition',
    value: function determineMaxLeftPosition(newX) {
      var leftBoundary = Math.abs(parseFloat(this.leftHandle.attr('x')) + this.maxClipSizePixels());
      return Math.min(leftBoundary, newX);
    }
  }, {
    key: 'rightAreaBoundary',
    value: function rightAreaBoundary(newX) {
      var maxRight = this.props.paddingLeft + this.props.areaWidth;
      return Math.min(newX, maxRight - parseFloat(this.clip.attr('width')));
    }
  }, {
    key: 'leftAreaBoundary',
    value: function leftAreaBoundary(newX) {
      return Math.max(this.props.paddingLeft, newX);
    }
  }, {
    key: 'teardownListeners',
    value: function teardownListeners() {
      this.clip.on('drag', null);
      this.leftHandle.on('drag', null);
      this.rightHandle.on('drag', null);
    }
  }]);
  return RangeSelector;
}(_react.Component);

RangeSelector.propTypes = {
  className: _propTypes2.default.string,
  onRangeChange: _propTypes2.default.func,
  handleWidth: _propTypes2.default.number,
  classNamePrefix: _propTypes2.default.string,
  width: _propTypes2.default.number,
  minClipSize: _propTypes2.default.number,
  maxClipSize: _propTypes2.default.number,
  areaWidth: _propTypes2.default.number,
  paddingTop: _propTypes2.default.number,
  paddingLeft: _propTypes2.default.number,
  paddingRight: _propTypes2.default.number,
  areaHeight: _propTypes2.default.number,
  xScale: _propTypes2.default.func,
  start: _propTypes2.default.object,
  end: _propTypes2.default.object
};
RangeSelector.defaultProps = {
  handleWidth: 5
};
var _default = RangeSelector;
exports.default = _default;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(RangeSelector, 'RangeSelector', 'src/layers/RangeSelector.js');

  __REACT_HOT_LOADER__.register(_default, 'default', 'src/layers/RangeSelector.js');
}();

;