'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _d3Selection = require('d3-selection');

var _d3Array = require('d3-array');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ScatterplotHighlighter = function (_Component) {
  (0, _inherits3.default)(ScatterplotHighlighter, _Component);

  function ScatterplotHighlighter() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, ScatterplotHighlighter);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = ScatterplotHighlighter.__proto__ || (0, _getPrototypeOf2.default)(ScatterplotHighlighter)).call.apply(_ref, [this].concat(args))), _this), _this.onMouseOver = function () {
      _this.node.selectAll('.scatterplot__dots__dot-highlight').attr('opacity', 1);
    }, _this.onMouseMove = function (_data, i, el) {
      var coords = (0, _d3Selection.mouse)(el[0]);
      var xPos = coords[0];
      var xScale = _this.props.xScale;
      var yScale = _this.props.yScale;
      var mouseDate = xScale.invert(xPos);
      var bisectDate = (0, _d3Array.bisector)(function (d) {
        return d.xValue;
      }).left;

      var chartData = _this.props.chartData;
      var index = bisectDate(chartData[0], mouseDate);
      if (index > 0 && index < chartData[0].length) {
        var d0 = chartData[0][index - 1];
        var d1 = chartData[0][index];
        index = mouseDate - d0.xValue > d1.xValue - mouseDate ? index : index - 1;
      } else if (index >= chartData[0].length) {
        index = chartData[0].length - 1;
      }

      var data = chartData.map(function (d) {
        return d[index];
      });

      if (_this.highlightedItem !== index) {
        _this.node.selectAll('.scatterplot__dots__dot-highlight').data(data).attr('cx', function (d) {
          return xScale(d.xValue || 0);
        }).attr('cy', function (d) {
          return yScale(d.yValue || 0);
        });

        _this.highlightedItem = index;
      }
    }, _this.onMouseOut = function () {
      _this.node.selectAll('.scatterplot__dots__dot-highlight').attr('opacity', 0);
      _this.highlightedItem = -1;
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(ScatterplotHighlighter, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.renderChart();
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      this.renderChart();
    }
  }, {
    key: 'getSVGNode',
    value: function getSVGNode(el) {
      var node = el.node();
      if (node.tagName.toLowerCase() === 'svg') {
        return node;
      }

      return node.ownerSVGElement;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var className = ['scatterplot-highlighter'];
      if (this.props.classNamePrefix) {
        className.push(this.props.classNamePrefix + '__scatterplot-highlighter');
      }
      if (this.props.className) {
        className.push(this.props.className);
      }
      return _react2.default.createElement(
        'g',
        {
          className: className.join(' '),
          transform: 'translate(' + this.props.paddingLeft + ',' + this.props.paddingTop + ')',
          ref: function ref(n) {
            return _this2.node = (0, _d3Selection.select)(n);
          }
        },
        this.renderHighlightContainer()
      );
    }
  }, {
    key: 'renderChart',
    value: function renderChart() {
      var data = this.props.chartData.map(function (d, i) {
        return i;
      });
      var hightlights = this.node.selectAll('.scatterplot__dots__dot-highlight').data(data);

      hightlights.exit().remove();

      hightlights.enter().append('circle').attr('class', function () {
        return 'scatterplot__dots__dot-highlight';
      }).attr('opacity', 0);

      if (this.props.highlightEventLayerName) {
        (0, _d3Selection.select)(this.getSVGNode(this.node)).select(this.props.highlightEventLayerName).on('mouseover.DotHighlighter', this.onMouseOver).on('mouseout.DotHighlighter', this.onMouseOut).on('mousemove.DotHighlighter', this.onMouseMove);
      } else {
        this.node.on('mouseover.DotHighlighter', this.onMouseOver).on('mouseout.DotHighlighter', this.onMouseOut).on('mousemove.DotHighlighter', this.onMouseMove);
      }
    }
  }, {
    key: 'renderHighlightContainer',
    value: function renderHighlightContainer() {
      var _this3 = this;

      if (this.props.highlightEventLayerName) return null;

      return _react2.default.createElement('rect', {
        x: '0',
        y: '0',
        width: this.props.width,
        height: this.props.height,
        fillOpacity: '0.0001',
        ref: function ref(n) {
          return _this3.eventnode = (0, _d3Selection.select)(n);
        }
      });
    }
  }]);
  return ScatterplotHighlighter;
}(_react.Component);

ScatterplotHighlighter.propTypes = {
  chartData: _propTypes2.default.array,
  className: _propTypes2.default.string,
  classNamePrefix: _propTypes2.default.string,
  height: _propTypes2.default.number,
  highlightEventLayerName: _propTypes2.default.string,
  paddingLeft: _propTypes2.default.number,
  paddingTop: _propTypes2.default.number,
  width: _propTypes2.default.number,
  xScale: _propTypes2.default.func,
  yScale: _propTypes2.default.func
};
ScatterplotHighlighter.defaultProps = {};
var _default = ScatterplotHighlighter;
exports.default = _default;
;

var _temp2 = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(ScatterplotHighlighter, 'ScatterplotHighlighter', 'src/layers/ScatterplotHighlighter.js');

  __REACT_HOT_LOADER__.register(_default, 'default', 'src/layers/ScatterplotHighlighter.js');
}();

;