'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _padDataBetweenDates = require('../helpers/padDataBetweenDates');

var _padDataBetweenDates2 = _interopRequireDefault(_padDataBetweenDates);

var _scaleHelpers = require('../helpers/scaleHelpers');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var PadDataBetweenDates = function (_Component) {
  (0, _inherits3.default)(PadDataBetweenDates, _Component);

  function PadDataBetweenDates() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, PadDataBetweenDates);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = PadDataBetweenDates.__proto__ || (0, _getPrototypeOf2.default)(PadDataBetweenDates)).call.apply(_ref, [this].concat(args))), _this), _this.renderChild = function (child) {
      var i = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;

      if (typeof child.type === 'string') {
        return child;
      }
      return _react2.default.cloneElement(child, (0, _extends3.default)({}, _this.props, child.props, {
        children: child.props.children,
        xScale: _this.xScale,
        yScale: _this.yScale,
        chartData: _this.chartData,
        key: i
      }));
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(PadDataBetweenDates, [{
    key: 'setupData',
    value: function setupData() {
      var _this2 = this;

      var startMoment = (0, _moment2.default)(this.props.startDate);
      var endMoment = (0, _moment2.default)(this.props.endDate);
      if (this.props.DEBUG) {
        /* eslint-disable no-console */
        console.debug('PadDataBetweenDates performing pad between\n                    ' + this.props.startDate + ' and ' + this.props.endDate + '\n                    with the pad interval of ' + this.props.dateInterval + ',\n                    with normalizing to start of ' + this.props.dateInterval + ' ' + (this.props.normalize ? 'enabled' : 'disabled') + '.');
      }
      if (this.props.startDate && this.props.endDate && startMoment.isBefore(endMoment)) {
        this.chartData = this.props.chartData.map(function (datum) {
          var first = _lodash2.default.first(datum) || {};
          return (0, _padDataBetweenDates2.default)(datum, _this2.props.startDate, _this2.props.endDate, _this2.props, _this2.props.padWith || (0, _extends3.default)({}, first, {
            yValue: undefined,
            xValue: undefined
          }));
        });
      } else {
        console.warn('PadDataBetweenDates received invalid startDate or endDate prop\nstartDate: ' + this.props.startDate + '\nendDate: ' + this.props.endDate + '\n');
        this.chartData = [];
      }
      this.xScale = this.props.xScale.copy();
      this.updateXScaleDomain();
      this.yScale = this.props.yScale.copy();
      (0, _scaleHelpers.updateYScaleDomain)(this.yScale, this.props, this.chartData);
    }
  }, {
    key: 'render',
    value: function render() {
      this.setupData();
      var name = 'pad-data-between-dates';
      var className = [name];
      if (this.props.classNamePrefix) {
        className.push(this.props.classNamePrefix + '__' + name);
      }
      if (this.props.className) {
        className.push(this.props.className);
      }
      return _react2.default.createElement(
        'g',
        { className: className.join(' ') },
        _react2.default.Children.map(this.props.children, this.renderChild)
      );
    }
  }, {
    key: 'updateXScaleDomain',
    value: function updateXScaleDomain() {
      var domain = void 0;
      if (this.props.xScaleDomain) {
        if (_lodash2.default.isFunction(this.props.xScaleDomain)) {
          domain = this.props.xScaleDomain(this.chartData);
        } else {
          domain = this.props.xScaleDomain;
        }
      } else if (this.props.normalize) {
        domain = [(0, _moment2.default)(this.props.startDate).startOf(this.props.dateInterval).toDate(), (0, _moment2.default)(this.props.endDate).startOf(this.props.dateInterval).toDate()];
      } else {
        domain = [this.props.startDate, this.props.endDate];
      }
      if (domain) {
        this.xScale.domain(domain);
        if (this.props.DEBUG) {
          /* eslint-disable no-console */
          console.debug('PadDataBetweenDates:xScale domain', domain);
          console.debug('PadDataBetweenDates:xScale range', this.xScale.range());
        }
      }
    }
  }]);
  return PadDataBetweenDates;
}(_react.Component);

PadDataBetweenDates.propTypes = {
  chartData: _propTypes2.default.array,
  children: _propTypes2.default.node,
  className: _propTypes2.default.string,
  classNamePrefix: _propTypes2.default.string,
  dateInterval: _propTypes2.default.string,
  domain: _propTypes2.default.bool,
  endDate: _propTypes2.default.instanceOf(Date),
  startDate: _propTypes2.default.instanceOf(Date),
  xScale: _propTypes2.default.func,
  xScaleDomain: _propTypes2.default.any,
  yScale: _propTypes2.default.func,
  yScaleDomain: _propTypes2.default.any,
  padWith: _propTypes2.default.any,
  normalize: _propTypes2.default.bool,
  DEBUG: _propTypes2.default.bool
};
PadDataBetweenDates.defaultProps = {
  dateInterval: 'day',
  normalize: true
};
var _default = PadDataBetweenDates;
exports.default = _default;
;

var _temp2 = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(PadDataBetweenDates, 'PadDataBetweenDates', 'src/manipulators/PadDataBetweenDates.js');

  __REACT_HOT_LOADER__.register(_default, 'default', 'src/manipulators/PadDataBetweenDates.js');
}();

;